/*
 * 柏九后端接口
 * ## 错误规则  ###    401 - 未登录，如果出现这个错误，请调用 登录/自动登录 接口刷新session或者requresttoken ###    403 - 权限不足， 一般不会出现这个错误 ###    417 - 碰到这个错误请将response的body解析为ErrorInfo一般情况是直接将ErrorInfo中的errorMessage 直接展现给用户 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package net.bojiu.android.io.swagger.api;

import net.bojiu.android.io.swagger.ApiCallback;
import net.bojiu.android.io.swagger.ApiClient;
import net.bojiu.android.io.swagger.ApiException;
import net.bojiu.android.io.swagger.ApiResponse;
import net.bojiu.android.io.swagger.Configuration;
import net.bojiu.android.io.swagger.Pair;
import net.bojiu.android.io.swagger.ProgressRequestBody;
import net.bojiu.android.io.swagger.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import net.bojiu.android.io.swagger.model.AuthorAuthInfo;
import net.bojiu.android.io.swagger.model.AuthorInfo;
import net.bojiu.android.io.swagger.model.Report;
import net.bojiu.android.io.swagger.model.UserInfo;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AdminAccountApi {
    private ApiClient apiClient;

    public AdminAccountApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AdminAccountApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for adminAuthorPost
     * @param email  (required)
     * @param password  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorPostCall(String email, String password, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/author";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (email != null)
        localVarFormParams.put("email", email);
        if (password != null)
        localVarFormParams.put("password", password);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorPostValidateBeforeCall(String email, String password, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'email' is set
        if (email == null) {
            throw new ApiException("Missing the required parameter 'email' when calling adminAuthorPost(Async)");
        }
        
        // verify the required parameter 'password' is set
        if (password == null) {
            throw new ApiException("Missing the required parameter 'password' when calling adminAuthorPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorPostCall(email, password, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 管理员创建用户
     * 
     * @param email  (required)
     * @param password  (required)
     * @return Integer
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Integer adminAuthorPost(String email, String password) throws ApiException {
        ApiResponse<Integer> resp = adminAuthorPostWithHttpInfo(email, password);
        return resp.getData();
    }

    /**
     * 管理员创建用户
     * 
     * @param email  (required)
     * @param password  (required)
     * @return ApiResponse&lt;Integer&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Integer> adminAuthorPostWithHttpInfo(String email, String password) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorPostValidateBeforeCall(email, password, null, null);
        Type localVarReturnType = new TypeToken<Integer>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 管理员创建用户 (asynchronously)
     * 
     * @param email  (required)
     * @param password  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorPostAsync(String email, String password, final ApiCallback<Integer> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorPostValidateBeforeCall(email, password, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Integer>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminAuthorsAuthInfoGet
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param authState 空或者ALL代表查询所有的，AUTHED 代表查询已认证通过的，INIT代表等待认证的，DENIED 代表认证未通过的 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthInfoGetCall(Integer pageNum, Integer pageSize, String authState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/authors/authInfo";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));
        if (authState != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "authState", authState));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorsAuthInfoGetValidateBeforeCall(Integer pageNum, Integer pageSize, String authState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminAuthorsAuthInfoGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling adminAuthorsAuthInfoGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorsAuthInfoGetCall(pageNum, pageSize, authState, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取所有的授权号认证信息
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param authState 空或者ALL代表查询所有的，AUTHED 代表查询已认证通过的，INIT代表等待认证的，DENIED 代表认证未通过的 (optional)
     * @return List&lt;AuthorAuthInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<AuthorAuthInfo> adminAuthorsAuthInfoGet(Integer pageNum, Integer pageSize, String authState) throws ApiException {
        ApiResponse<List<AuthorAuthInfo>> resp = adminAuthorsAuthInfoGetWithHttpInfo(pageNum, pageSize, authState);
        return resp.getData();
    }

    /**
     * 获取所有的授权号认证信息
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param authState 空或者ALL代表查询所有的，AUTHED 代表查询已认证通过的，INIT代表等待认证的，DENIED 代表认证未通过的 (optional)
     * @return ApiResponse&lt;List&lt;AuthorAuthInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<AuthorAuthInfo>> adminAuthorsAuthInfoGetWithHttpInfo(Integer pageNum, Integer pageSize, String authState) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorsAuthInfoGetValidateBeforeCall(pageNum, pageSize, authState, null, null);
        Type localVarReturnType = new TypeToken<List<AuthorAuthInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取所有的授权号认证信息 (asynchronously)
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param authState 空或者ALL代表查询所有的，AUTHED 代表查询已认证通过的，INIT代表等待认证的，DENIED 代表认证未通过的 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthInfoGetAsync(Integer pageNum, Integer pageSize, String authState, final ApiCallback<List<AuthorAuthInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorsAuthInfoGetValidateBeforeCall(pageNum, pageSize, authState, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<AuthorAuthInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminAuthorsAuthorIdAuthInfoGet
     * @param authorId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdAuthInfoGetCall(Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/authors/{authorId}/authInfo"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorsAuthorIdAuthInfoGetValidateBeforeCall(Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorsAuthorIdAuthInfoGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdAuthInfoGetCall(authorId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取单个授权号认证信息
     * 
     * @param authorId  (required)
     * @return AuthorAuthInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public AuthorAuthInfo adminAuthorsAuthorIdAuthInfoGet(Integer authorId) throws ApiException {
        ApiResponse<AuthorAuthInfo> resp = adminAuthorsAuthorIdAuthInfoGetWithHttpInfo(authorId);
        return resp.getData();
    }

    /**
     * 获取单个授权号认证信息
     * 
     * @param authorId  (required)
     * @return ApiResponse&lt;AuthorAuthInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<AuthorAuthInfo> adminAuthorsAuthorIdAuthInfoGetWithHttpInfo(Integer authorId) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdAuthInfoGetValidateBeforeCall(authorId, null, null);
        Type localVarReturnType = new TypeToken<AuthorAuthInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取单个授权号认证信息 (asynchronously)
     * 
     * @param authorId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdAuthInfoGetAsync(Integer authorId, final ApiCallback<AuthorAuthInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorsAuthorIdAuthInfoGetValidateBeforeCall(authorId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<AuthorAuthInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminAuthorsAuthorIdAuthInfoPost
     * @param authorId  (required)
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdAuthInfoPostCall(Integer authorId, AuthorAuthInfo authorInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = authorInfo;
        
        // create path and map variables
        String localVarPath = "/admin/authors/{authorId}/authInfo"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorsAuthorIdAuthInfoPostValidateBeforeCall(Integer authorId, AuthorAuthInfo authorInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorsAuthorIdAuthInfoPost(Async)");
        }
        
        // verify the required parameter 'authorInfo' is set
        if (authorInfo == null) {
            throw new ApiException("Missing the required parameter 'authorInfo' when calling adminAuthorsAuthorIdAuthInfoPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdAuthInfoPostCall(authorId, authorInfo, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 修改单个授权号认证信息
     * 
     * @param authorId  (required)
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminAuthorsAuthorIdAuthInfoPost(Integer authorId, AuthorAuthInfo authorInfo) throws ApiException {
        adminAuthorsAuthorIdAuthInfoPostWithHttpInfo(authorId, authorInfo);
    }

    /**
     * 修改单个授权号认证信息
     * 
     * @param authorId  (required)
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminAuthorsAuthorIdAuthInfoPostWithHttpInfo(Integer authorId, AuthorAuthInfo authorInfo) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdAuthInfoPostValidateBeforeCall(authorId, authorInfo, null, null);
        return apiClient.execute(call);
    }

    /**
     * 修改单个授权号认证信息 (asynchronously)
     * 
     * @param authorId  (required)
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdAuthInfoPostAsync(Integer authorId, AuthorAuthInfo authorInfo, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorsAuthorIdAuthInfoPostValidateBeforeCall(authorId, authorInfo, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminAuthorsAuthorIdAuthPost
     * @param authorId  (required)
     * @param email email (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdAuthPostCall(Integer authorId, String email, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/authors/{authorId}/auth"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (email != null)
        localVarFormParams.put("email", email);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorsAuthorIdAuthPostValidateBeforeCall(Integer authorId, String email, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorsAuthorIdAuthPost(Async)");
        }
        
        // verify the required parameter 'email' is set
        if (email == null) {
            throw new ApiException("Missing the required parameter 'email' when calling adminAuthorsAuthorIdAuthPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdAuthPostCall(authorId, email, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 认证通过这个授权号
     * 
     * @param authorId  (required)
     * @param email email (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminAuthorsAuthorIdAuthPost(Integer authorId, String email) throws ApiException {
        adminAuthorsAuthorIdAuthPostWithHttpInfo(authorId, email);
    }

    /**
     * 认证通过这个授权号
     * 
     * @param authorId  (required)
     * @param email email (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminAuthorsAuthorIdAuthPostWithHttpInfo(Integer authorId, String email) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdAuthPostValidateBeforeCall(authorId, email, null, null);
        return apiClient.execute(call);
    }

    /**
     * 认证通过这个授权号 (asynchronously)
     * 
     * @param authorId  (required)
     * @param email email (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdAuthPostAsync(Integer authorId, String email, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorsAuthorIdAuthPostValidateBeforeCall(authorId, email, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminAuthorsAuthorIdDenyPost
     * @param authorId  (required)
     * @param email 邮件地址 (required)
     * @param reason 不通过的原因 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdDenyPostCall(Integer authorId, String email, String reason, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/authors/{authorId}/deny"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (email != null)
        localVarFormParams.put("email", email);
        if (reason != null)
        localVarFormParams.put("reason", reason);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorsAuthorIdDenyPostValidateBeforeCall(Integer authorId, String email, String reason, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorsAuthorIdDenyPost(Async)");
        }
        
        // verify the required parameter 'email' is set
        if (email == null) {
            throw new ApiException("Missing the required parameter 'email' when calling adminAuthorsAuthorIdDenyPost(Async)");
        }
        
        // verify the required parameter 'reason' is set
        if (reason == null) {
            throw new ApiException("Missing the required parameter 'reason' when calling adminAuthorsAuthorIdDenyPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdDenyPostCall(authorId, email, reason, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 拒绝这个授权号
     * 
     * @param authorId  (required)
     * @param email 邮件地址 (required)
     * @param reason 不通过的原因 (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminAuthorsAuthorIdDenyPost(Integer authorId, String email, String reason) throws ApiException {
        adminAuthorsAuthorIdDenyPostWithHttpInfo(authorId, email, reason);
    }

    /**
     * 拒绝这个授权号
     * 
     * @param authorId  (required)
     * @param email 邮件地址 (required)
     * @param reason 不通过的原因 (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminAuthorsAuthorIdDenyPostWithHttpInfo(Integer authorId, String email, String reason) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdDenyPostValidateBeforeCall(authorId, email, reason, null, null);
        return apiClient.execute(call);
    }

    /**
     * 拒绝这个授权号 (asynchronously)
     * 
     * @param authorId  (required)
     * @param email 邮件地址 (required)
     * @param reason 不通过的原因 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdDenyPostAsync(Integer authorId, String email, String reason, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorsAuthorIdDenyPostValidateBeforeCall(authorId, email, reason, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminAuthorsAuthorIdGet
     * @param authorId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdGetCall(Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/authors/{authorId}"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorsAuthorIdGetValidateBeforeCall(Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorsAuthorIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdGetCall(authorId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取单个授权号信息
     * 
     * @param authorId  (required)
     * @return AuthorInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public AuthorInfo adminAuthorsAuthorIdGet(Integer authorId) throws ApiException {
        ApiResponse<AuthorInfo> resp = adminAuthorsAuthorIdGetWithHttpInfo(authorId);
        return resp.getData();
    }

    /**
     * 获取单个授权号信息
     * 
     * @param authorId  (required)
     * @return ApiResponse&lt;AuthorInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<AuthorInfo> adminAuthorsAuthorIdGetWithHttpInfo(Integer authorId) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdGetValidateBeforeCall(authorId, null, null);
        Type localVarReturnType = new TypeToken<AuthorInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取单个授权号信息 (asynchronously)
     * 
     * @param authorId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdGetAsync(Integer authorId, final ApiCallback<AuthorInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorsAuthorIdGetValidateBeforeCall(authorId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<AuthorInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminAuthorsAuthorIdPost
     * @param authorId  (required)
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdPostCall(Integer authorId, AuthorInfo authorInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = authorInfo;
        
        // create path and map variables
        String localVarPath = "/admin/authors/{authorId}"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorsAuthorIdPostValidateBeforeCall(Integer authorId, AuthorInfo authorInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorsAuthorIdPost(Async)");
        }
        
        // verify the required parameter 'authorInfo' is set
        if (authorInfo == null) {
            throw new ApiException("Missing the required parameter 'authorInfo' when calling adminAuthorsAuthorIdPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdPostCall(authorId, authorInfo, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 修改授权号的个人信息
     * 
     * @param authorId  (required)
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminAuthorsAuthorIdPost(Integer authorId, AuthorInfo authorInfo) throws ApiException {
        adminAuthorsAuthorIdPostWithHttpInfo(authorId, authorInfo);
    }

    /**
     * 修改授权号的个人信息
     * 
     * @param authorId  (required)
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminAuthorsAuthorIdPostWithHttpInfo(Integer authorId, AuthorInfo authorInfo) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdPostValidateBeforeCall(authorId, authorInfo, null, null);
        return apiClient.execute(call);
    }

    /**
     * 修改授权号的个人信息 (asynchronously)
     * 
     * @param authorId  (required)
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdPostAsync(Integer authorId, AuthorInfo authorInfo, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorsAuthorIdPostValidateBeforeCall(authorId, authorInfo, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminAuthorsGet
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param authState 空或者ALL代表查询所有的，AUTHED 代表查询已认证通过的，INIT代表等待认证的，DENIED 代表认证未通过的 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsGetCall(Integer pageNum, Integer pageSize, String authState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/authors";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));
        if (authState != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "authState", authState));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorsGetValidateBeforeCall(Integer pageNum, Integer pageSize, String authState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminAuthorsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling adminAuthorsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorsGetCall(pageNum, pageSize, authState, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取所有的授权号信息
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param authState 空或者ALL代表查询所有的，AUTHED 代表查询已认证通过的，INIT代表等待认证的，DENIED 代表认证未通过的 (optional)
     * @return List&lt;AuthorInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<AuthorInfo> adminAuthorsGet(Integer pageNum, Integer pageSize, String authState) throws ApiException {
        ApiResponse<List<AuthorInfo>> resp = adminAuthorsGetWithHttpInfo(pageNum, pageSize, authState);
        return resp.getData();
    }

    /**
     * 获取所有的授权号信息
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param authState 空或者ALL代表查询所有的，AUTHED 代表查询已认证通过的，INIT代表等待认证的，DENIED 代表认证未通过的 (optional)
     * @return ApiResponse&lt;List&lt;AuthorInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<AuthorInfo>> adminAuthorsGetWithHttpInfo(Integer pageNum, Integer pageSize, String authState) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorsGetValidateBeforeCall(pageNum, pageSize, authState, null, null);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取所有的授权号信息 (asynchronously)
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param authState 空或者ALL代表查询所有的，AUTHED 代表查询已认证通过的，INIT代表等待认证的，DENIED 代表认证未通过的 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsGetAsync(Integer pageNum, Integer pageSize, String authState, final ApiCallback<List<AuthorInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorsGetValidateBeforeCall(pageNum, pageSize, authState, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminReportReportIdDelete
     * @param reportId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminReportReportIdDeleteCall(Integer reportId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/report/{reportId}"
            .replaceAll("\\{" + "reportId" + "\\}", apiClient.escapeString(reportId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminReportReportIdDeleteValidateBeforeCall(Integer reportId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'reportId' is set
        if (reportId == null) {
            throw new ApiException("Missing the required parameter 'reportId' when calling adminReportReportIdDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminReportReportIdDeleteCall(reportId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 删除举报建议
     * 
     * @param reportId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminReportReportIdDelete(Integer reportId) throws ApiException {
        adminReportReportIdDeleteWithHttpInfo(reportId);
    }

    /**
     * 删除举报建议
     * 
     * @param reportId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminReportReportIdDeleteWithHttpInfo(Integer reportId) throws ApiException {
        com.squareup.okhttp.Call call = adminReportReportIdDeleteValidateBeforeCall(reportId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 删除举报建议 (asynchronously)
     * 
     * @param reportId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminReportReportIdDeleteAsync(Integer reportId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminReportReportIdDeleteValidateBeforeCall(reportId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminReportsGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminReportsGetCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/reports";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminReportsGetValidateBeforeCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminReportsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling adminReportsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminReportsGetCall(pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取举报建议
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;Report&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Report> adminReportsGet(Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<Report>> resp = adminReportsGetWithHttpInfo(pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取举报建议
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;Report&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Report>> adminReportsGetWithHttpInfo(Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = adminReportsGetValidateBeforeCall(pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<Report>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取举报建议 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminReportsGetAsync(Integer pageNum, Integer pageSize, final ApiCallback<List<Report>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminReportsGetValidateBeforeCall(pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Report>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminUsersGet
     * @param pageNum  (required)
     * @param pageSize  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminUsersGetCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/users";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminUsersGetValidateBeforeCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminUsersGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminUsersGetCall(pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取所有的用户
     * 
     * @param pageNum  (required)
     * @param pageSize  (optional)
     * @return List&lt;UserInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<UserInfo> adminUsersGet(Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<UserInfo>> resp = adminUsersGetWithHttpInfo(pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取所有的用户
     * 
     * @param pageNum  (required)
     * @param pageSize  (optional)
     * @return ApiResponse&lt;List&lt;UserInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<UserInfo>> adminUsersGetWithHttpInfo(Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = adminUsersGetValidateBeforeCall(pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<UserInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取所有的用户 (asynchronously)
     * 
     * @param pageNum  (required)
     * @param pageSize  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminUsersGetAsync(Integer pageNum, Integer pageSize, final ApiCallback<List<UserInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminUsersGetValidateBeforeCall(pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<UserInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminUsersUserIdGet
     * @param userId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminUsersUserIdGetCall(Integer userId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/users/{userId}"
            .replaceAll("\\{" + "userId" + "\\}", apiClient.escapeString(userId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminUsersUserIdGetValidateBeforeCall(Integer userId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'userId' is set
        if (userId == null) {
            throw new ApiException("Missing the required parameter 'userId' when calling adminUsersUserIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminUsersUserIdGetCall(userId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取单个用户
     * 
     * @param userId  (required)
     * @return UserInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public UserInfo adminUsersUserIdGet(Integer userId) throws ApiException {
        ApiResponse<UserInfo> resp = adminUsersUserIdGetWithHttpInfo(userId);
        return resp.getData();
    }

    /**
     * 获取单个用户
     * 
     * @param userId  (required)
     * @return ApiResponse&lt;UserInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<UserInfo> adminUsersUserIdGetWithHttpInfo(Integer userId) throws ApiException {
        com.squareup.okhttp.Call call = adminUsersUserIdGetValidateBeforeCall(userId, null, null);
        Type localVarReturnType = new TypeToken<UserInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取单个用户 (asynchronously)
     * 
     * @param userId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminUsersUserIdGetAsync(Integer userId, final ApiCallback<UserInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminUsersUserIdGetValidateBeforeCall(userId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<UserInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
