/*
 * 柏九后端接口
 * ## 错误规则  ###    401 - 未登录，如果出现这个错误，请调用 登录/自动登录 接口刷新session或者requresttoken ###    403 - 权限不足， 一般不会出现这个错误 ###    417 - 碰到这个错误请将response的body解析为ErrorInfo一般情况是直接将ErrorInfo中的errorMessage 直接展现给用户 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package net.bojiu.android.io.swagger.api;

import net.bojiu.android.io.swagger.ApiCallback;
import net.bojiu.android.io.swagger.ApiClient;
import net.bojiu.android.io.swagger.ApiException;
import net.bojiu.android.io.swagger.ApiResponse;
import net.bojiu.android.io.swagger.Configuration;
import net.bojiu.android.io.swagger.Pair;
import net.bojiu.android.io.swagger.ProgressRequestBody;
import net.bojiu.android.io.swagger.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import net.bojiu.android.io.swagger.model.AuthorInfo;
import net.bojiu.android.io.swagger.model.Cluster;
import net.bojiu.android.io.swagger.model.ClusterProductionCounts;
import net.bojiu.android.io.swagger.model.ProductionDetail;
import net.bojiu.android.io.swagger.model.ProductionPlayTop;
import net.bojiu.android.io.swagger.model.ProductionUpload;
import net.bojiu.android.io.swagger.model.RegisterFrom;
import net.bojiu.android.io.swagger.model.RegisterMachine;
import net.bojiu.android.io.swagger.model.StartAppTimes;
import net.bojiu.android.io.swagger.model.SystemInfoPages;
import net.bojiu.android.io.swagger.model.Tag;
import net.bojiu.android.io.swagger.model.UserAvgPlayCounts;
import net.bojiu.android.io.swagger.model.UserAvgPlayDuration;
import net.bojiu.android.io.swagger.model.UserPlayCounts;
import net.bojiu.android.io.swagger.model.UserPlayStatisticsInfos;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AdminApi {
    private ApiClient apiClient;

    public AdminApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AdminApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for adminAuthorIdAuthorCancelIstopPost
     * @param authorId 需要取消置顶的授权号id (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorIdAuthorCancelIstopPostCall(Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/{authorId}/authorCancelIstop"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorIdAuthorCancelIstopPostValidateBeforeCall(Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorIdAuthorCancelIstopPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorIdAuthorCancelIstopPostCall(authorId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 取消授权号置顶
     * 
     * @param authorId 需要取消置顶的授权号id (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminAuthorIdAuthorCancelIstopPost(Integer authorId) throws ApiException {
        adminAuthorIdAuthorCancelIstopPostWithHttpInfo(authorId);
    }

    /**
     * 取消授权号置顶
     * 
     * @param authorId 需要取消置顶的授权号id (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminAuthorIdAuthorCancelIstopPostWithHttpInfo(Integer authorId) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorIdAuthorCancelIstopPostValidateBeforeCall(authorId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 取消授权号置顶 (asynchronously)
     * 
     * @param authorId 需要取消置顶的授权号id (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorIdAuthorCancelIstopPostAsync(Integer authorId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorIdAuthorCancelIstopPostValidateBeforeCall(authorId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminAuthorIdForbiddenOrStartUsingAuthorPost
     * @param authorId 授权号id (required)
     * @param type 类型（禁用：1，启用：2） (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorIdForbiddenOrStartUsingAuthorPostCall(Integer authorId, Integer type, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/{author_id}/forbiddenOrStartUsingAuthor"
            .replaceAll("\\{" + "author_id" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (type != null)
        localVarFormParams.put("type", type);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorIdForbiddenOrStartUsingAuthorPostValidateBeforeCall(Integer authorId, Integer type, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorIdForbiddenOrStartUsingAuthorPost(Async)");
        }
        
        // verify the required parameter 'type' is set
        if (type == null) {
            throw new ApiException("Missing the required parameter 'type' when calling adminAuthorIdForbiddenOrStartUsingAuthorPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorIdForbiddenOrStartUsingAuthorPostCall(authorId, type, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 启用或者禁用某个授权号
     * 
     * @param authorId 授权号id (required)
     * @param type 类型（禁用：1，启用：2） (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminAuthorIdForbiddenOrStartUsingAuthorPost(Integer authorId, Integer type) throws ApiException {
        adminAuthorIdForbiddenOrStartUsingAuthorPostWithHttpInfo(authorId, type);
    }

    /**
     * 启用或者禁用某个授权号
     * 
     * @param authorId 授权号id (required)
     * @param type 类型（禁用：1，启用：2） (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminAuthorIdForbiddenOrStartUsingAuthorPostWithHttpInfo(Integer authorId, Integer type) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorIdForbiddenOrStartUsingAuthorPostValidateBeforeCall(authorId, type, null, null);
        return apiClient.execute(call);
    }

    /**
     * 启用或者禁用某个授权号 (asynchronously)
     * 
     * @param authorId 授权号id (required)
     * @param type 类型（禁用：1，启用：2） (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorIdForbiddenOrStartUsingAuthorPostAsync(Integer authorId, Integer type, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorIdForbiddenOrStartUsingAuthorPostValidateBeforeCall(authorId, type, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminAuthorIstopPost
     * @param authorId 需要置顶的授权号id (required)
     * @param pageNum 第几页 (required)
     * @param pageSize 每页显示多少条数据 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorIstopPostCall(Integer authorId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/authorIstop";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (authorId != null)
        localVarFormParams.put("authorId", authorId);
        if (pageNum != null)
        localVarFormParams.put("pageNum", pageNum);
        if (pageSize != null)
        localVarFormParams.put("pageSize", pageSize);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorIstopPostValidateBeforeCall(Integer authorId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorIstopPost(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminAuthorIstopPost(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling adminAuthorIstopPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorIstopPostCall(authorId, pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 授权号置顶
     * 
     * @param authorId 需要置顶的授权号id (required)
     * @param pageNum 第几页 (required)
     * @param pageSize 每页显示多少条数据 (required)
     * @return List&lt;AuthorInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<AuthorInfo> adminAuthorIstopPost(Integer authorId, Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<AuthorInfo>> resp = adminAuthorIstopPostWithHttpInfo(authorId, pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 授权号置顶
     * 
     * @param authorId 需要置顶的授权号id (required)
     * @param pageNum 第几页 (required)
     * @param pageSize 每页显示多少条数据 (required)
     * @return ApiResponse&lt;List&lt;AuthorInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<AuthorInfo>> adminAuthorIstopPostWithHttpInfo(Integer authorId, Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorIstopPostValidateBeforeCall(authorId, pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 授权号置顶 (asynchronously)
     * 
     * @param authorId 需要置顶的授权号id (required)
     * @param pageNum 第几页 (required)
     * @param pageSize 每页显示多少条数据 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorIstopPostAsync(Integer authorId, Integer pageNum, Integer pageSize, final ApiCallback<List<AuthorInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorIstopPostValidateBeforeCall(authorId, pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminAuthorsAuthorIdProductionsGet
     * @param authorId 作者的ID (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authState 认证状态 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdProductionsGetCall(Integer authorId, Integer pageNum, Integer pageSize, String authState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/authors/{authorId}/productions"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));
        if (authState != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "authState", authState));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminAuthorsAuthorIdProductionsGetValidateBeforeCall(Integer authorId, Integer pageNum, Integer pageSize, String authState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling adminAuthorsAuthorIdProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminAuthorsAuthorIdProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling adminAuthorsAuthorIdProductionsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdProductionsGetCall(authorId, pageNum, pageSize, authState, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取某个作者的所有作品
     * 
     * @param authorId 作者的ID (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authState 认证状态 (optional)
     * @return List&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionDetail> adminAuthorsAuthorIdProductionsGet(Integer authorId, Integer pageNum, Integer pageSize, String authState) throws ApiException {
        ApiResponse<List<ProductionDetail>> resp = adminAuthorsAuthorIdProductionsGetWithHttpInfo(authorId, pageNum, pageSize, authState);
        return resp.getData();
    }

    /**
     * 获取某个作者的所有作品
     * 
     * @param authorId 作者的ID (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authState 认证状态 (optional)
     * @return ApiResponse&lt;List&lt;ProductionDetail&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionDetail>> adminAuthorsAuthorIdProductionsGetWithHttpInfo(Integer authorId, Integer pageNum, Integer pageSize, String authState) throws ApiException {
        com.squareup.okhttp.Call call = adminAuthorsAuthorIdProductionsGetValidateBeforeCall(authorId, pageNum, pageSize, authState, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取某个作者的所有作品 (asynchronously)
     * 
     * @param authorId 作者的ID (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authState 认证状态 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminAuthorsAuthorIdProductionsGetAsync(Integer authorId, Integer pageNum, Integer pageSize, String authState, final ApiCallback<List<ProductionDetail>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminAuthorsAuthorIdProductionsGetValidateBeforeCall(authorId, pageNum, pageSize, authState, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminClustersClusterIdDelete
     * @param clusterId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminClustersClusterIdDeleteCall(Integer clusterId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/clusters/{clusterId}"
            .replaceAll("\\{" + "clusterId" + "\\}", apiClient.escapeString(clusterId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminClustersClusterIdDeleteValidateBeforeCall(Integer clusterId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterId' is set
        if (clusterId == null) {
            throw new ApiException("Missing the required parameter 'clusterId' when calling adminClustersClusterIdDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminClustersClusterIdDeleteCall(clusterId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 
     * 
     * @param clusterId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminClustersClusterIdDelete(Integer clusterId) throws ApiException {
        adminClustersClusterIdDeleteWithHttpInfo(clusterId);
    }

    /**
     * 
     * 
     * @param clusterId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminClustersClusterIdDeleteWithHttpInfo(Integer clusterId) throws ApiException {
        com.squareup.okhttp.Call call = adminClustersClusterIdDeleteValidateBeforeCall(clusterId, null, null);
        return apiClient.execute(call);
    }

    /**
     *  (asynchronously)
     * 
     * @param clusterId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminClustersClusterIdDeleteAsync(Integer clusterId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminClustersClusterIdDeleteValidateBeforeCall(clusterId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminClustersClusterIdPost
     * @param clusterId  (required)
     * @param cluster  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminClustersClusterIdPostCall(Integer clusterId, Cluster cluster, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = cluster;
        
        // create path and map variables
        String localVarPath = "/admin/clusters/{clusterId}"
            .replaceAll("\\{" + "clusterId" + "\\}", apiClient.escapeString(clusterId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminClustersClusterIdPostValidateBeforeCall(Integer clusterId, Cluster cluster, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterId' is set
        if (clusterId == null) {
            throw new ApiException("Missing the required parameter 'clusterId' when calling adminClustersClusterIdPost(Async)");
        }
        
        // verify the required parameter 'cluster' is set
        if (cluster == null) {
            throw new ApiException("Missing the required parameter 'cluster' when calling adminClustersClusterIdPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminClustersClusterIdPostCall(clusterId, cluster, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 修改某个分类
     * 
     * @param clusterId  (required)
     * @param cluster  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminClustersClusterIdPost(Integer clusterId, Cluster cluster) throws ApiException {
        adminClustersClusterIdPostWithHttpInfo(clusterId, cluster);
    }

    /**
     * 修改某个分类
     * 
     * @param clusterId  (required)
     * @param cluster  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminClustersClusterIdPostWithHttpInfo(Integer clusterId, Cluster cluster) throws ApiException {
        com.squareup.okhttp.Call call = adminClustersClusterIdPostValidateBeforeCall(clusterId, cluster, null, null);
        return apiClient.execute(call);
    }

    /**
     * 修改某个分类 (asynchronously)
     * 
     * @param clusterId  (required)
     * @param cluster  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminClustersClusterIdPostAsync(Integer clusterId, Cluster cluster, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminClustersClusterIdPostValidateBeforeCall(clusterId, cluster, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminClustersPost
     * @param cluster  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminClustersPostCall(Cluster cluster, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = cluster;
        
        // create path and map variables
        String localVarPath = "/admin/clusters";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminClustersPostValidateBeforeCall(Cluster cluster, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'cluster' is set
        if (cluster == null) {
            throw new ApiException("Missing the required parameter 'cluster' when calling adminClustersPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminClustersPostCall(cluster, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 
     * 
     * @param cluster  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminClustersPost(Cluster cluster) throws ApiException {
        adminClustersPostWithHttpInfo(cluster);
    }

    /**
     * 
     * 
     * @param cluster  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminClustersPostWithHttpInfo(Cluster cluster) throws ApiException {
        com.squareup.okhttp.Call call = adminClustersPostValidateBeforeCall(cluster, null, null);
        return apiClient.execute(call);
    }

    /**
     *  (asynchronously)
     * 
     * @param cluster  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminClustersPostAsync(Cluster cluster, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminClustersPostValidateBeforeCall(cluster, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminDeleteCommentCommentIdDelete
     * @param commentId 评论id (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminDeleteCommentCommentIdDeleteCall(Integer commentId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/deleteComment/{commentId}"
            .replaceAll("\\{" + "commentId" + "\\}", apiClient.escapeString(commentId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminDeleteCommentCommentIdDeleteValidateBeforeCall(Integer commentId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'commentId' is set
        if (commentId == null) {
            throw new ApiException("Missing the required parameter 'commentId' when calling adminDeleteCommentCommentIdDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminDeleteCommentCommentIdDeleteCall(commentId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 根据评论id删除评论
     * 
     * @param commentId 评论id (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminDeleteCommentCommentIdDelete(Integer commentId) throws ApiException {
        adminDeleteCommentCommentIdDeleteWithHttpInfo(commentId);
    }

    /**
     * 根据评论id删除评论
     * 
     * @param commentId 评论id (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminDeleteCommentCommentIdDeleteWithHttpInfo(Integer commentId) throws ApiException {
        com.squareup.okhttp.Call call = adminDeleteCommentCommentIdDeleteValidateBeforeCall(commentId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 根据评论id删除评论 (asynchronously)
     * 
     * @param commentId 评论id (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminDeleteCommentCommentIdDeleteAsync(Integer commentId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminDeleteCommentCommentIdDeleteValidateBeforeCall(commentId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminEditorSystemPost
     * @param infoId 需要编辑信息id (required)
     * @param systemName 需要编辑名称 (required)
     * @param systemcontent 需要编辑内容 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminEditorSystemPostCall(Integer infoId, String systemName, String systemcontent, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/editorSystem";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (infoId != null)
        localVarFormParams.put("info_id", infoId);
        if (systemName != null)
        localVarFormParams.put("SystemName", systemName);
        if (systemcontent != null)
        localVarFormParams.put("Systemcontent", systemcontent);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminEditorSystemPostValidateBeforeCall(Integer infoId, String systemName, String systemcontent, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'infoId' is set
        if (infoId == null) {
            throw new ApiException("Missing the required parameter 'infoId' when calling adminEditorSystemPost(Async)");
        }
        
        // verify the required parameter 'systemName' is set
        if (systemName == null) {
            throw new ApiException("Missing the required parameter 'systemName' when calling adminEditorSystemPost(Async)");
        }
        
        // verify the required parameter 'systemcontent' is set
        if (systemcontent == null) {
            throw new ApiException("Missing the required parameter 'systemcontent' when calling adminEditorSystemPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminEditorSystemPostCall(infoId, systemName, systemcontent, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 编辑系统信息
     * 
     * @param infoId 需要编辑信息id (required)
     * @param systemName 需要编辑名称 (required)
     * @param systemcontent 需要编辑内容 (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminEditorSystemPost(Integer infoId, String systemName, String systemcontent) throws ApiException {
        adminEditorSystemPostWithHttpInfo(infoId, systemName, systemcontent);
    }

    /**
     * 编辑系统信息
     * 
     * @param infoId 需要编辑信息id (required)
     * @param systemName 需要编辑名称 (required)
     * @param systemcontent 需要编辑内容 (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminEditorSystemPostWithHttpInfo(Integer infoId, String systemName, String systemcontent) throws ApiException {
        com.squareup.okhttp.Call call = adminEditorSystemPostValidateBeforeCall(infoId, systemName, systemcontent, null, null);
        return apiClient.execute(call);
    }

    /**
     * 编辑系统信息 (asynchronously)
     * 
     * @param infoId 需要编辑信息id (required)
     * @param systemName 需要编辑名称 (required)
     * @param systemcontent 需要编辑内容 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminEditorSystemPostAsync(Integer infoId, String systemName, String systemcontent, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminEditorSystemPostValidateBeforeCall(infoId, systemName, systemcontent, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminGetAllProductionCountsGet
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetAllProductionCountsGetCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getAllProductionCounts";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetAllProductionCountsGetValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetAllProductionCountsGetCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取所有的作品数量
     * 
     * @return Integer
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Integer adminGetAllProductionCountsGet() throws ApiException {
        ApiResponse<Integer> resp = adminGetAllProductionCountsGetWithHttpInfo();
        return resp.getData();
    }

    /**
     * 获取所有的作品数量
     * 
     * @return ApiResponse&lt;Integer&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Integer> adminGetAllProductionCountsGetWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = adminGetAllProductionCountsGetValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<Integer>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取所有的作品数量 (asynchronously)
     * 
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetAllProductionCountsGetAsync(final ApiCallback<Integer> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetAllProductionCountsGetValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Integer>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetAuthorRecommendGet
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetAuthorRecommendGetCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getAuthorRecommend";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetAuthorRecommendGetValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetAuthorRecommendGetCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取授权号推荐位
     * 
     * @return List&lt;AuthorInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<AuthorInfo> adminGetAuthorRecommendGet() throws ApiException {
        ApiResponse<List<AuthorInfo>> resp = adminGetAuthorRecommendGetWithHttpInfo();
        return resp.getData();
    }

    /**
     * 获取授权号推荐位
     * 
     * @return ApiResponse&lt;List&lt;AuthorInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<AuthorInfo>> adminGetAuthorRecommendGetWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = adminGetAuthorRecommendGetValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取授权号推荐位 (asynchronously)
     * 
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetAuthorRecommendGetAsync(final ApiCallback<List<AuthorInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetAuthorRecommendGetValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetClusterProductionCountsGet
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetClusterProductionCountsGetCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getClusterProductionCounts";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetClusterProductionCountsGetValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetClusterProductionCountsGetCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取各种分类下的做品数量
     * 
     * @return List&lt;ClusterProductionCounts&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ClusterProductionCounts> adminGetClusterProductionCountsGet() throws ApiException {
        ApiResponse<List<ClusterProductionCounts>> resp = adminGetClusterProductionCountsGetWithHttpInfo();
        return resp.getData();
    }

    /**
     * 获取各种分类下的做品数量
     * 
     * @return ApiResponse&lt;List&lt;ClusterProductionCounts&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ClusterProductionCounts>> adminGetClusterProductionCountsGetWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = adminGetClusterProductionCountsGetValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<List<ClusterProductionCounts>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取各种分类下的做品数量 (asynchronously)
     * 
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetClusterProductionCountsGetAsync(final ApiCallback<List<ClusterProductionCounts>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetClusterProductionCountsGetValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ClusterProductionCounts>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetProductionPlayTopPost
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetProductionPlayTopPostCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getProductionPlayTop";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (startTime != null)
        localVarFormParams.put("startTime", startTime);
        if (endTime != null)
        localVarFormParams.put("endTime", endTime);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetProductionPlayTopPostValidateBeforeCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetProductionPlayTopPostCall(startTime, endTime, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取作品播放top 10
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return List&lt;ProductionPlayTop&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionPlayTop> adminGetProductionPlayTopPost(String startTime, String endTime) throws ApiException {
        ApiResponse<List<ProductionPlayTop>> resp = adminGetProductionPlayTopPostWithHttpInfo(startTime, endTime);
        return resp.getData();
    }

    /**
     * 获取作品播放top 10
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return ApiResponse&lt;List&lt;ProductionPlayTop&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionPlayTop>> adminGetProductionPlayTopPostWithHttpInfo(String startTime, String endTime) throws ApiException {
        com.squareup.okhttp.Call call = adminGetProductionPlayTopPostValidateBeforeCall(startTime, endTime, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionPlayTop>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取作品播放top 10 (asynchronously)
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetProductionPlayTopPostAsync(String startTime, String endTime, final ApiCallback<List<ProductionPlayTop>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetProductionPlayTopPostValidateBeforeCall(startTime, endTime, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionPlayTop>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetRegisterFromPost
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束时间节点 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetRegisterFromPostCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getRegisterFrom";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (startTime != null)
        localVarFormParams.put("startTime", startTime);
        if (endTime != null)
        localVarFormParams.put("endTime", endTime);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetRegisterFromPostValidateBeforeCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetRegisterFromPostCall(startTime, endTime, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取用户注册渠道列表（注册账号）
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束时间节点 (optional)
     * @return List&lt;RegisterFrom&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<RegisterFrom> adminGetRegisterFromPost(String startTime, String endTime) throws ApiException {
        ApiResponse<List<RegisterFrom>> resp = adminGetRegisterFromPostWithHttpInfo(startTime, endTime);
        return resp.getData();
    }

    /**
     * 获取用户注册渠道列表（注册账号）
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束时间节点 (optional)
     * @return ApiResponse&lt;List&lt;RegisterFrom&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<RegisterFrom>> adminGetRegisterFromPostWithHttpInfo(String startTime, String endTime) throws ApiException {
        com.squareup.okhttp.Call call = adminGetRegisterFromPostValidateBeforeCall(startTime, endTime, null, null);
        Type localVarReturnType = new TypeToken<List<RegisterFrom>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取用户注册渠道列表（注册账号） (asynchronously)
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束时间节点 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetRegisterFromPostAsync(String startTime, String endTime, final ApiCallback<List<RegisterFrom>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetRegisterFromPostValidateBeforeCall(startTime, endTime, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<RegisterFrom>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetRegisterMachinePost
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束时间节点 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetRegisterMachinePostCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getRegisterMachine";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (startTime != null)
        localVarFormParams.put("startTime", startTime);
        if (endTime != null)
        localVarFormParams.put("endTime", endTime);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetRegisterMachinePostValidateBeforeCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetRegisterMachinePostCall(startTime, endTime, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取用户注册渠道列表（注册客户端）
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束时间节点 (optional)
     * @return List&lt;RegisterMachine&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<RegisterMachine> adminGetRegisterMachinePost(String startTime, String endTime) throws ApiException {
        ApiResponse<List<RegisterMachine>> resp = adminGetRegisterMachinePostWithHttpInfo(startTime, endTime);
        return resp.getData();
    }

    /**
     * 获取用户注册渠道列表（注册客户端）
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束时间节点 (optional)
     * @return ApiResponse&lt;List&lt;RegisterMachine&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<RegisterMachine>> adminGetRegisterMachinePostWithHttpInfo(String startTime, String endTime) throws ApiException {
        com.squareup.okhttp.Call call = adminGetRegisterMachinePostValidateBeforeCall(startTime, endTime, null, null);
        Type localVarReturnType = new TypeToken<List<RegisterMachine>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取用户注册渠道列表（注册客户端） (asynchronously)
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束时间节点 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetRegisterMachinePostAsync(String startTime, String endTime, final ApiCallback<List<RegisterMachine>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetRegisterMachinePostValidateBeforeCall(startTime, endTime, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<RegisterMachine>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetStartAppOpentimesPost
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetStartAppOpentimesPostCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getStartAppOpentimes";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (startTime != null)
        localVarFormParams.put("startTime", startTime);
        if (endTime != null)
        localVarFormParams.put("endTime", endTime);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetStartAppOpentimesPostValidateBeforeCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetStartAppOpentimesPostCall(startTime, endTime, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 通过时间节点获取启动APP次数和时长
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return List&lt;StartAppTimes&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<StartAppTimes> adminGetStartAppOpentimesPost(String startTime, String endTime) throws ApiException {
        ApiResponse<List<StartAppTimes>> resp = adminGetStartAppOpentimesPostWithHttpInfo(startTime, endTime);
        return resp.getData();
    }

    /**
     * 通过时间节点获取启动APP次数和时长
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return ApiResponse&lt;List&lt;StartAppTimes&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<StartAppTimes>> adminGetStartAppOpentimesPostWithHttpInfo(String startTime, String endTime) throws ApiException {
        com.squareup.okhttp.Call call = adminGetStartAppOpentimesPostValidateBeforeCall(startTime, endTime, null, null);
        Type localVarReturnType = new TypeToken<List<StartAppTimes>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 通过时间节点获取启动APP次数和时长 (asynchronously)
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetStartAppOpentimesPostAsync(String startTime, String endTime, final ApiCallback<List<StartAppTimes>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetStartAppOpentimesPostValidateBeforeCall(startTime, endTime, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<StartAppTimes>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetSystemInfoPagesGet
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetSystemInfoPagesGetCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getSystemInfoPages";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetSystemInfoPagesGetValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetSystemInfoPagesGetCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取后台系统信息页面 【关于我们】-》【用户协议】-》【功能说明】
     * 
     * @return List&lt;SystemInfoPages&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<SystemInfoPages> adminGetSystemInfoPagesGet() throws ApiException {
        ApiResponse<List<SystemInfoPages>> resp = adminGetSystemInfoPagesGetWithHttpInfo();
        return resp.getData();
    }

    /**
     * 获取后台系统信息页面 【关于我们】-》【用户协议】-》【功能说明】
     * 
     * @return ApiResponse&lt;List&lt;SystemInfoPages&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<SystemInfoPages>> adminGetSystemInfoPagesGetWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = adminGetSystemInfoPagesGetValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<List<SystemInfoPages>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取后台系统信息页面 【关于我们】-》【用户协议】-》【功能说明】 (asynchronously)
     * 
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetSystemInfoPagesGetAsync(final ApiCallback<List<SystemInfoPages>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetSystemInfoPagesGetValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<SystemInfoPages>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetUserAvgPlayDurationPost
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetUserAvgPlayDurationPostCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getUserAvgPlayDuration";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (startTime != null)
        localVarFormParams.put("startTime", startTime);
        if (endTime != null)
        localVarFormParams.put("endTime", endTime);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetUserAvgPlayDurationPostValidateBeforeCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetUserAvgPlayDurationPostCall(startTime, endTime, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取用户人均播放时长
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return List&lt;UserAvgPlayDuration&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<UserAvgPlayDuration> adminGetUserAvgPlayDurationPost(String startTime, String endTime) throws ApiException {
        ApiResponse<List<UserAvgPlayDuration>> resp = adminGetUserAvgPlayDurationPostWithHttpInfo(startTime, endTime);
        return resp.getData();
    }

    /**
     * 获取用户人均播放时长
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return ApiResponse&lt;List&lt;UserAvgPlayDuration&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<UserAvgPlayDuration>> adminGetUserAvgPlayDurationPostWithHttpInfo(String startTime, String endTime) throws ApiException {
        com.squareup.okhttp.Call call = adminGetUserAvgPlayDurationPostValidateBeforeCall(startTime, endTime, null, null);
        Type localVarReturnType = new TypeToken<List<UserAvgPlayDuration>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取用户人均播放时长 (asynchronously)
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetUserAvgPlayDurationPostAsync(String startTime, String endTime, final ApiCallback<List<UserAvgPlayDuration>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetUserAvgPlayDurationPostValidateBeforeCall(startTime, endTime, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<UserAvgPlayDuration>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetUserAvgUserPlayCountsPost
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetUserAvgUserPlayCountsPostCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getUserAvgUserPlayCounts";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (startTime != null)
        localVarFormParams.put("startTime", startTime);
        if (endTime != null)
        localVarFormParams.put("endTime", endTime);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetUserAvgUserPlayCountsPostValidateBeforeCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetUserAvgUserPlayCountsPostCall(startTime, endTime, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取用户人均播放次数
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return List&lt;UserAvgPlayCounts&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<UserAvgPlayCounts> adminGetUserAvgUserPlayCountsPost(String startTime, String endTime) throws ApiException {
        ApiResponse<List<UserAvgPlayCounts>> resp = adminGetUserAvgUserPlayCountsPostWithHttpInfo(startTime, endTime);
        return resp.getData();
    }

    /**
     * 获取用户人均播放次数
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return ApiResponse&lt;List&lt;UserAvgPlayCounts&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<UserAvgPlayCounts>> adminGetUserAvgUserPlayCountsPostWithHttpInfo(String startTime, String endTime) throws ApiException {
        com.squareup.okhttp.Call call = adminGetUserAvgUserPlayCountsPostValidateBeforeCall(startTime, endTime, null, null);
        Type localVarReturnType = new TypeToken<List<UserAvgPlayCounts>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取用户人均播放次数 (asynchronously)
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetUserAvgUserPlayCountsPostAsync(String startTime, String endTime, final ApiCallback<List<UserAvgPlayCounts>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetUserAvgUserPlayCountsPostValidateBeforeCall(startTime, endTime, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<UserAvgPlayCounts>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminGetUserPlayCountsPost
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminGetUserPlayCountsPostCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/getUserPlayCounts";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (startTime != null)
        localVarFormParams.put("startTime", startTime);
        if (endTime != null)
        localVarFormParams.put("endTime", endTime);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminGetUserPlayCountsPostValidateBeforeCall(String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = adminGetUserPlayCountsPostCall(startTime, endTime, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取用户播放次数【按照客户端维度统计】
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return List&lt;UserPlayCounts&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<UserPlayCounts> adminGetUserPlayCountsPost(String startTime, String endTime) throws ApiException {
        ApiResponse<List<UserPlayCounts>> resp = adminGetUserPlayCountsPostWithHttpInfo(startTime, endTime);
        return resp.getData();
    }

    /**
     * 获取用户播放次数【按照客户端维度统计】
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @return ApiResponse&lt;List&lt;UserPlayCounts&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<UserPlayCounts>> adminGetUserPlayCountsPostWithHttpInfo(String startTime, String endTime) throws ApiException {
        com.squareup.okhttp.Call call = adminGetUserPlayCountsPostValidateBeforeCall(startTime, endTime, null, null);
        Type localVarReturnType = new TypeToken<List<UserPlayCounts>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取用户播放次数【按照客户端维度统计】 (asynchronously)
     * 
     * @param startTime 开始节点时间 (optional)
     * @param endTime 结束节点时间 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminGetUserPlayCountsPostAsync(String startTime, String endTime, final ApiCallback<List<UserPlayCounts>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminGetUserPlayCountsPostValidateBeforeCall(startTime, endTime, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<UserPlayCounts>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminProductionsGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authState 认证状态 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminProductionsGetCall(Integer pageNum, Integer pageSize, String authState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/productions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));
        if (authState != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "authState", authState));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminProductionsGetValidateBeforeCall(Integer pageNum, Integer pageSize, String authState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling adminProductionsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminProductionsGetCall(pageNum, pageSize, authState, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取所有作品
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authState 认证状态 (optional)
     * @return List&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionDetail> adminProductionsGet(Integer pageNum, Integer pageSize, String authState) throws ApiException {
        ApiResponse<List<ProductionDetail>> resp = adminProductionsGetWithHttpInfo(pageNum, pageSize, authState);
        return resp.getData();
    }

    /**
     * 获取所有作品
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authState 认证状态 (optional)
     * @return ApiResponse&lt;List&lt;ProductionDetail&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionDetail>> adminProductionsGetWithHttpInfo(Integer pageNum, Integer pageSize, String authState) throws ApiException {
        com.squareup.okhttp.Call call = adminProductionsGetValidateBeforeCall(pageNum, pageSize, authState, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取所有作品 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authState 认证状态 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminProductionsGetAsync(Integer pageNum, Integer pageSize, String authState, final ApiCallback<List<ProductionDetail>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminProductionsGetValidateBeforeCall(pageNum, pageSize, authState, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminProductionsPost
     * @param production  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminProductionsPostCall(ProductionUpload production, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = production;
        
        // create path and map variables
        String localVarPath = "/admin/productions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminProductionsPostValidateBeforeCall(ProductionUpload production, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'production' is set
        if (production == null) {
            throw new ApiException("Missing the required parameter 'production' when calling adminProductionsPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminProductionsPostCall(production, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 管理员作品创建接口
     * 
     * @param production  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminProductionsPost(ProductionUpload production) throws ApiException {
        adminProductionsPostWithHttpInfo(production);
    }

    /**
     * 管理员作品创建接口
     * 
     * @param production  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminProductionsPostWithHttpInfo(ProductionUpload production) throws ApiException {
        com.squareup.okhttp.Call call = adminProductionsPostValidateBeforeCall(production, null, null);
        return apiClient.execute(call);
    }

    /**
     * 管理员作品创建接口 (asynchronously)
     * 
     * @param production  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminProductionsPostAsync(ProductionUpload production, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminProductionsPostValidateBeforeCall(production, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminProductionsProductionIdAuthPost
     * @param productionId  (required)
     * @param email email (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminProductionsProductionIdAuthPostCall(Integer productionId, String email, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/productions/{productionId}/auth"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (email != null)
        localVarFormParams.put("email", email);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminProductionsProductionIdAuthPostValidateBeforeCall(Integer productionId, String email, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling adminProductionsProductionIdAuthPost(Async)");
        }
        
        // verify the required parameter 'email' is set
        if (email == null) {
            throw new ApiException("Missing the required parameter 'email' when calling adminProductionsProductionIdAuthPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminProductionsProductionIdAuthPostCall(productionId, email, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 审核通过找个视频
     * 
     * @param productionId  (required)
     * @param email email (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminProductionsProductionIdAuthPost(Integer productionId, String email) throws ApiException {
        adminProductionsProductionIdAuthPostWithHttpInfo(productionId, email);
    }

    /**
     * 审核通过找个视频
     * 
     * @param productionId  (required)
     * @param email email (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminProductionsProductionIdAuthPostWithHttpInfo(Integer productionId, String email) throws ApiException {
        com.squareup.okhttp.Call call = adminProductionsProductionIdAuthPostValidateBeforeCall(productionId, email, null, null);
        return apiClient.execute(call);
    }

    /**
     * 审核通过找个视频 (asynchronously)
     * 
     * @param productionId  (required)
     * @param email email (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminProductionsProductionIdAuthPostAsync(Integer productionId, String email, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminProductionsProductionIdAuthPostValidateBeforeCall(productionId, email, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminProductionsProductionIdDenyPost
     * @param productionId  (required)
     * @param reason  (required)
     * @param email 邮件 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminProductionsProductionIdDenyPostCall(Integer productionId, String reason, String email, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/productions/{productionId}/deny"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (reason != null)
        localVarFormParams.put("reason", reason);
        if (email != null)
        localVarFormParams.put("email", email);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminProductionsProductionIdDenyPostValidateBeforeCall(Integer productionId, String reason, String email, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling adminProductionsProductionIdDenyPost(Async)");
        }
        
        // verify the required parameter 'reason' is set
        if (reason == null) {
            throw new ApiException("Missing the required parameter 'reason' when calling adminProductionsProductionIdDenyPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminProductionsProductionIdDenyPostCall(productionId, reason, email, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 审核不通过
     * 
     * @param productionId  (required)
     * @param reason  (required)
     * @param email 邮件 (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminProductionsProductionIdDenyPost(Integer productionId, String reason, String email) throws ApiException {
        adminProductionsProductionIdDenyPostWithHttpInfo(productionId, reason, email);
    }

    /**
     * 审核不通过
     * 
     * @param productionId  (required)
     * @param reason  (required)
     * @param email 邮件 (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminProductionsProductionIdDenyPostWithHttpInfo(Integer productionId, String reason, String email) throws ApiException {
        com.squareup.okhttp.Call call = adminProductionsProductionIdDenyPostValidateBeforeCall(productionId, reason, email, null, null);
        return apiClient.execute(call);
    }

    /**
     * 审核不通过 (asynchronously)
     * 
     * @param productionId  (required)
     * @param reason  (required)
     * @param email 邮件 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminProductionsProductionIdDenyPostAsync(Integer productionId, String reason, String email, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminProductionsProductionIdDenyPostValidateBeforeCall(productionId, reason, email, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminProductionsProductionIdPutawayDelete
     * @param productionId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminProductionsProductionIdPutawayDeleteCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/productions/{productionId}/putaway"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminProductionsProductionIdPutawayDeleteValidateBeforeCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling adminProductionsProductionIdPutawayDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminProductionsProductionIdPutawayDeleteCall(productionId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 作品下架
     * 
     * @param productionId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminProductionsProductionIdPutawayDelete(Integer productionId) throws ApiException {
        adminProductionsProductionIdPutawayDeleteWithHttpInfo(productionId);
    }

    /**
     * 作品下架
     * 
     * @param productionId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminProductionsProductionIdPutawayDeleteWithHttpInfo(Integer productionId) throws ApiException {
        com.squareup.okhttp.Call call = adminProductionsProductionIdPutawayDeleteValidateBeforeCall(productionId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 作品下架 (asynchronously)
     * 
     * @param productionId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminProductionsProductionIdPutawayDeleteAsync(Integer productionId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminProductionsProductionIdPutawayDeleteValidateBeforeCall(productionId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminProductionsProductionIdPutawayPost
     * @param productionId  (required)
     * @param clusterId  (required)
     * @param isHot  (required)
     * @param isTop 是否为精选 (required)
     * @param selfMade 是否为自制 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminProductionsProductionIdPutawayPostCall(Integer productionId, Integer clusterId, Boolean isHot, Boolean isTop, Boolean selfMade, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/productions/{productionId}/putaway"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (clusterId != null)
        localVarFormParams.put("clusterId", clusterId);
        if (isHot != null)
        localVarFormParams.put("isHot", isHot);
        if (isTop != null)
        localVarFormParams.put("isTop", isTop);
        if (selfMade != null)
        localVarFormParams.put("selfMade", selfMade);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminProductionsProductionIdPutawayPostValidateBeforeCall(Integer productionId, Integer clusterId, Boolean isHot, Boolean isTop, Boolean selfMade, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling adminProductionsProductionIdPutawayPost(Async)");
        }
        
        // verify the required parameter 'clusterId' is set
        if (clusterId == null) {
            throw new ApiException("Missing the required parameter 'clusterId' when calling adminProductionsProductionIdPutawayPost(Async)");
        }
        
        // verify the required parameter 'isHot' is set
        if (isHot == null) {
            throw new ApiException("Missing the required parameter 'isHot' when calling adminProductionsProductionIdPutawayPost(Async)");
        }
        
        // verify the required parameter 'isTop' is set
        if (isTop == null) {
            throw new ApiException("Missing the required parameter 'isTop' when calling adminProductionsProductionIdPutawayPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminProductionsProductionIdPutawayPostCall(productionId, clusterId, isHot, isTop, selfMade, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 作品上架
     * 
     * @param productionId  (required)
     * @param clusterId  (required)
     * @param isHot  (required)
     * @param isTop 是否为精选 (required)
     * @param selfMade 是否为自制 (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminProductionsProductionIdPutawayPost(Integer productionId, Integer clusterId, Boolean isHot, Boolean isTop, Boolean selfMade) throws ApiException {
        adminProductionsProductionIdPutawayPostWithHttpInfo(productionId, clusterId, isHot, isTop, selfMade);
    }

    /**
     * 作品上架
     * 
     * @param productionId  (required)
     * @param clusterId  (required)
     * @param isHot  (required)
     * @param isTop 是否为精选 (required)
     * @param selfMade 是否为自制 (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminProductionsProductionIdPutawayPostWithHttpInfo(Integer productionId, Integer clusterId, Boolean isHot, Boolean isTop, Boolean selfMade) throws ApiException {
        com.squareup.okhttp.Call call = adminProductionsProductionIdPutawayPostValidateBeforeCall(productionId, clusterId, isHot, isTop, selfMade, null, null);
        return apiClient.execute(call);
    }

    /**
     * 作品上架 (asynchronously)
     * 
     * @param productionId  (required)
     * @param clusterId  (required)
     * @param isHot  (required)
     * @param isTop 是否为精选 (required)
     * @param selfMade 是否为自制 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminProductionsProductionIdPutawayPostAsync(Integer productionId, Integer clusterId, Boolean isHot, Boolean isTop, Boolean selfMade, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminProductionsProductionIdPutawayPostValidateBeforeCall(productionId, clusterId, isHot, isTop, selfMade, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminProputawayStateGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param putawyState 上架状态 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminProputawayStateGetCall(Integer pageNum, Integer pageSize, String putawyState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/proputawayState";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));
        if (putawyState != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "putawy_state", putawyState));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminProputawayStateGetValidateBeforeCall(Integer pageNum, Integer pageSize, String putawyState, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminProputawayStateGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling adminProputawayStateGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminProputawayStateGetCall(pageNum, pageSize, putawyState, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取所有作品【上架和未上架】
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param putawyState 上架状态 (optional)
     * @return List&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionDetail> adminProputawayStateGet(Integer pageNum, Integer pageSize, String putawyState) throws ApiException {
        ApiResponse<List<ProductionDetail>> resp = adminProputawayStateGetWithHttpInfo(pageNum, pageSize, putawyState);
        return resp.getData();
    }

    /**
     * 获取所有作品【上架和未上架】
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param putawyState 上架状态 (optional)
     * @return ApiResponse&lt;List&lt;ProductionDetail&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionDetail>> adminProputawayStateGetWithHttpInfo(Integer pageNum, Integer pageSize, String putawyState) throws ApiException {
        com.squareup.okhttp.Call call = adminProputawayStateGetValidateBeforeCall(pageNum, pageSize, putawyState, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取所有作品【上架和未上架】 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param putawyState 上架状态 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminProputawayStateGetAsync(Integer pageNum, Integer pageSize, String putawyState, final ApiCallback<List<ProductionDetail>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminProputawayStateGetValidateBeforeCall(pageNum, pageSize, putawyState, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminSearchselectproductionsGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param seleMade 是否为自制 0 自制 1 平台方创建 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminSearchselectproductionsGetCall(Integer pageNum, Integer pageSize, Integer seleMade, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/searchselectproductions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));
        if (seleMade != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "sele_made", seleMade));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminSearchselectproductionsGetValidateBeforeCall(Integer pageNum, Integer pageSize, Integer seleMade, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminSearchselectproductionsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling adminSearchselectproductionsGet(Async)");
        }
        
        // verify the required parameter 'seleMade' is set
        if (seleMade == null) {
            throw new ApiException("Missing the required parameter 'seleMade' when calling adminSearchselectproductionsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminSearchselectproductionsGetCall(pageNum, pageSize, seleMade, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取下拉筛选的作品【自制还是平台方创建】
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param seleMade 是否为自制 0 自制 1 平台方创建 (required)
     * @return List&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionDetail> adminSearchselectproductionsGet(Integer pageNum, Integer pageSize, Integer seleMade) throws ApiException {
        ApiResponse<List<ProductionDetail>> resp = adminSearchselectproductionsGetWithHttpInfo(pageNum, pageSize, seleMade);
        return resp.getData();
    }

    /**
     * 获取下拉筛选的作品【自制还是平台方创建】
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param seleMade 是否为自制 0 自制 1 平台方创建 (required)
     * @return ApiResponse&lt;List&lt;ProductionDetail&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionDetail>> adminSearchselectproductionsGetWithHttpInfo(Integer pageNum, Integer pageSize, Integer seleMade) throws ApiException {
        com.squareup.okhttp.Call call = adminSearchselectproductionsGetValidateBeforeCall(pageNum, pageSize, seleMade, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取下拉筛选的作品【自制还是平台方创建】 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param seleMade 是否为自制 0 自制 1 平台方创建 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminSearchselectproductionsGetAsync(Integer pageNum, Integer pageSize, Integer seleMade, final ApiCallback<List<ProductionDetail>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminSearchselectproductionsGetValidateBeforeCall(pageNum, pageSize, seleMade, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminTagIdTagCancelIstopPost
     * @param tagId 需要取消置顶的授权号id (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminTagIdTagCancelIstopPostCall(Integer tagId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/{tag_id}/tagCancelIstop"
            .replaceAll("\\{" + "tag_id" + "\\}", apiClient.escapeString(tagId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminTagIdTagCancelIstopPostValidateBeforeCall(Integer tagId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tagId' is set
        if (tagId == null) {
            throw new ApiException("Missing the required parameter 'tagId' when calling adminTagIdTagCancelIstopPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminTagIdTagCancelIstopPostCall(tagId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 取消关键词置顶
     * 
     * @param tagId 需要取消置顶的授权号id (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminTagIdTagCancelIstopPost(Integer tagId) throws ApiException {
        adminTagIdTagCancelIstopPostWithHttpInfo(tagId);
    }

    /**
     * 取消关键词置顶
     * 
     * @param tagId 需要取消置顶的授权号id (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminTagIdTagCancelIstopPostWithHttpInfo(Integer tagId) throws ApiException {
        com.squareup.okhttp.Call call = adminTagIdTagCancelIstopPostValidateBeforeCall(tagId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 取消关键词置顶 (asynchronously)
     * 
     * @param tagId 需要取消置顶的授权号id (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminTagIdTagCancelIstopPostAsync(Integer tagId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminTagIdTagCancelIstopPostValidateBeforeCall(tagId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminTagsIstopPost
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param tagId tag_id (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminTagsIstopPostCall(Integer pageNum, Integer pageSize, Integer tagId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/TagsIstop";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (tagId != null)
        localVarFormParams.put("tag_id", tagId);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminTagsIstopPostValidateBeforeCall(Integer pageNum, Integer pageSize, Integer tagId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling adminTagsIstopPost(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling adminTagsIstopPost(Async)");
        }
        
        // verify the required parameter 'tagId' is set
        if (tagId == null) {
            throw new ApiException("Missing the required parameter 'tagId' when calling adminTagsIstopPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminTagsIstopPostCall(pageNum, pageSize, tagId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 关键词tag置顶
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param tagId tag_id (required)
     * @return List&lt;Tag&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Tag> adminTagsIstopPost(Integer pageNum, Integer pageSize, Integer tagId) throws ApiException {
        ApiResponse<List<Tag>> resp = adminTagsIstopPostWithHttpInfo(pageNum, pageSize, tagId);
        return resp.getData();
    }

    /**
     * 关键词tag置顶
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param tagId tag_id (required)
     * @return ApiResponse&lt;List&lt;Tag&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Tag>> adminTagsIstopPostWithHttpInfo(Integer pageNum, Integer pageSize, Integer tagId) throws ApiException {
        com.squareup.okhttp.Call call = adminTagsIstopPostValidateBeforeCall(pageNum, pageSize, tagId, null, null);
        Type localVarReturnType = new TypeToken<List<Tag>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 关键词tag置顶 (asynchronously)
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param tagId tag_id (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminTagsIstopPostAsync(Integer pageNum, Integer pageSize, Integer tagId, final ApiCallback<List<Tag>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminTagsIstopPostValidateBeforeCall(pageNum, pageSize, tagId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Tag>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminTagsPost
     * @param tag  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminTagsPostCall(Tag tag, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = tag;
        
        // create path and map variables
        String localVarPath = "/admin/tags";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminTagsPostValidateBeforeCall(Tag tag, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tag' is set
        if (tag == null) {
            throw new ApiException("Missing the required parameter 'tag' when calling adminTagsPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminTagsPostCall(tag, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 
     * 
     * @param tag  (required)
     * @return Integer
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Integer adminTagsPost(Tag tag) throws ApiException {
        ApiResponse<Integer> resp = adminTagsPostWithHttpInfo(tag);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param tag  (required)
     * @return ApiResponse&lt;Integer&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Integer> adminTagsPostWithHttpInfo(Tag tag) throws ApiException {
        com.squareup.okhttp.Call call = adminTagsPostValidateBeforeCall(tag, null, null);
        Type localVarReturnType = new TypeToken<Integer>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     *  (asynchronously)
     * 
     * @param tag  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminTagsPostAsync(Tag tag, final ApiCallback<Integer> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminTagsPostValidateBeforeCall(tag, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Integer>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminTagsTagIdDelete
     * @param tagId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminTagsTagIdDeleteCall(Integer tagId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/tags/{tagId}"
            .replaceAll("\\{" + "tagId" + "\\}", apiClient.escapeString(tagId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminTagsTagIdDeleteValidateBeforeCall(Integer tagId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tagId' is set
        if (tagId == null) {
            throw new ApiException("Missing the required parameter 'tagId' when calling adminTagsTagIdDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminTagsTagIdDeleteCall(tagId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 删除这个关键词
     * 
     * @param tagId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminTagsTagIdDelete(Integer tagId) throws ApiException {
        adminTagsTagIdDeleteWithHttpInfo(tagId);
    }

    /**
     * 删除这个关键词
     * 
     * @param tagId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminTagsTagIdDeleteWithHttpInfo(Integer tagId) throws ApiException {
        com.squareup.okhttp.Call call = adminTagsTagIdDeleteValidateBeforeCall(tagId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 删除这个关键词 (asynchronously)
     * 
     * @param tagId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminTagsTagIdDeleteAsync(Integer tagId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminTagsTagIdDeleteValidateBeforeCall(tagId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminTagsTagIdPost
     * @param tagId  (required)
     * @param tag  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminTagsTagIdPostCall(Integer tagId, Tag tag, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = tag;
        
        // create path and map variables
        String localVarPath = "/admin/tags/{tagId}"
            .replaceAll("\\{" + "tagId" + "\\}", apiClient.escapeString(tagId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminTagsTagIdPostValidateBeforeCall(Integer tagId, Tag tag, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tagId' is set
        if (tagId == null) {
            throw new ApiException("Missing the required parameter 'tagId' when calling adminTagsTagIdPost(Async)");
        }
        
        // verify the required parameter 'tag' is set
        if (tag == null) {
            throw new ApiException("Missing the required parameter 'tag' when calling adminTagsTagIdPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminTagsTagIdPostCall(tagId, tag, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 修改这个关键词
     * 
     * @param tagId  (required)
     * @param tag  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminTagsTagIdPost(Integer tagId, Tag tag) throws ApiException {
        adminTagsTagIdPostWithHttpInfo(tagId, tag);
    }

    /**
     * 修改这个关键词
     * 
     * @param tagId  (required)
     * @param tag  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminTagsTagIdPostWithHttpInfo(Integer tagId, Tag tag) throws ApiException {
        com.squareup.okhttp.Call call = adminTagsTagIdPostValidateBeforeCall(tagId, tag, null, null);
        return apiClient.execute(call);
    }

    /**
     * 修改这个关键词 (asynchronously)
     * 
     * @param tagId  (required)
     * @param tag  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminTagsTagIdPostAsync(Integer tagId, Tag tag, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminTagsTagIdPostValidateBeforeCall(tagId, tag, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminUserInfoUserIdPut
     * @param userId  (required)
     * @param name  (optional)
     * @param headImagePath  (optional)
     * @param status  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminUserInfoUserIdPutCall(Integer userId, String name, String headImagePath, String status, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/userInfo/{userId}"
            .replaceAll("\\{" + "userId" + "\\}", apiClient.escapeString(userId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (name != null)
        localVarFormParams.put("name", name);
        if (headImagePath != null)
        localVarFormParams.put("headImagePath", headImagePath);
        if (status != null)
        localVarFormParams.put("status", status);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminUserInfoUserIdPutValidateBeforeCall(Integer userId, String name, String headImagePath, String status, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'userId' is set
        if (userId == null) {
            throw new ApiException("Missing the required parameter 'userId' when calling adminUserInfoUserIdPut(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminUserInfoUserIdPutCall(userId, name, headImagePath, status, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 管理员修改用户信息
     * 
     * @param userId  (required)
     * @param name  (optional)
     * @param headImagePath  (optional)
     * @param status  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void adminUserInfoUserIdPut(Integer userId, String name, String headImagePath, String status) throws ApiException {
        adminUserInfoUserIdPutWithHttpInfo(userId, name, headImagePath, status);
    }

    /**
     * 管理员修改用户信息
     * 
     * @param userId  (required)
     * @param name  (optional)
     * @param headImagePath  (optional)
     * @param status  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> adminUserInfoUserIdPutWithHttpInfo(Integer userId, String name, String headImagePath, String status) throws ApiException {
        com.squareup.okhttp.Call call = adminUserInfoUserIdPutValidateBeforeCall(userId, name, headImagePath, status, null, null);
        return apiClient.execute(call);
    }

    /**
     * 管理员修改用户信息 (asynchronously)
     * 
     * @param userId  (required)
     * @param name  (optional)
     * @param headImagePath  (optional)
     * @param status  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminUserInfoUserIdPutAsync(Integer userId, String name, String headImagePath, String status, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminUserInfoUserIdPutValidateBeforeCall(userId, name, headImagePath, status, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for adminUserPlayStatisticsInfosPost
     * @param action 系统参数 填写DescribeUserUvByDay (required)
     * @param videoType 视频型号 live VOD (required)
     * @param startTime 开始时间 (required)
     * @param endTime 结束时间 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminUserPlayStatisticsInfosPostCall(String action, String videoType, String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/UserPlayStatisticsInfos";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (action != null)
        localVarFormParams.put("Action", action);
        if (videoType != null)
        localVarFormParams.put("VideoType", videoType);
        if (startTime != null)
        localVarFormParams.put("StartTime", startTime);
        if (endTime != null)
        localVarFormParams.put("EndTime", endTime);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminUserPlayStatisticsInfosPostValidateBeforeCall(String action, String videoType, String startTime, String endTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'action' is set
        if (action == null) {
            throw new ApiException("Missing the required parameter 'action' when calling adminUserPlayStatisticsInfosPost(Async)");
        }
        
        // verify the required parameter 'videoType' is set
        if (videoType == null) {
            throw new ApiException("Missing the required parameter 'videoType' when calling adminUserPlayStatisticsInfosPost(Async)");
        }
        
        // verify the required parameter 'startTime' is set
        if (startTime == null) {
            throw new ApiException("Missing the required parameter 'startTime' when calling adminUserPlayStatisticsInfosPost(Async)");
        }
        
        // verify the required parameter 'endTime' is set
        if (endTime == null) {
            throw new ApiException("Missing the required parameter 'endTime' when calling adminUserPlayStatisticsInfosPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminUserPlayStatisticsInfosPostCall(action, videoType, startTime, endTime, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取视频单日播放量
     * 
     * @param action 系统参数 填写DescribeUserUvByDay (required)
     * @param videoType 视频型号 live VOD (required)
     * @param startTime 开始时间 (required)
     * @param endTime 结束时间 (required)
     * @return UserPlayStatisticsInfos
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public UserPlayStatisticsInfos adminUserPlayStatisticsInfosPost(String action, String videoType, String startTime, String endTime) throws ApiException {
        ApiResponse<UserPlayStatisticsInfos> resp = adminUserPlayStatisticsInfosPostWithHttpInfo(action, videoType, startTime, endTime);
        return resp.getData();
    }

    /**
     * 获取视频单日播放量
     * 
     * @param action 系统参数 填写DescribeUserUvByDay (required)
     * @param videoType 视频型号 live VOD (required)
     * @param startTime 开始时间 (required)
     * @param endTime 结束时间 (required)
     * @return ApiResponse&lt;UserPlayStatisticsInfos&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<UserPlayStatisticsInfos> adminUserPlayStatisticsInfosPostWithHttpInfo(String action, String videoType, String startTime, String endTime) throws ApiException {
        com.squareup.okhttp.Call call = adminUserPlayStatisticsInfosPostValidateBeforeCall(action, videoType, startTime, endTime, null, null);
        Type localVarReturnType = new TypeToken<UserPlayStatisticsInfos>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取视频单日播放量 (asynchronously)
     * 
     * @param action 系统参数 填写DescribeUserUvByDay (required)
     * @param videoType 视频型号 live VOD (required)
     * @param startTime 开始时间 (required)
     * @param endTime 结束时间 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminUserPlayStatisticsInfosPostAsync(String action, String videoType, String startTime, String endTime, final ApiCallback<UserPlayStatisticsInfos> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminUserPlayStatisticsInfosPostValidateBeforeCall(action, videoType, startTime, endTime, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<UserPlayStatisticsInfos>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for adminWatchInfoInfoIdGet
     * @param infoId info_id (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call adminWatchInfoInfoIdGetCall(Integer infoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/admin/watchInfo/{info_id}"
            .replaceAll("\\{" + "info_id" + "\\}", apiClient.escapeString(infoId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call adminWatchInfoInfoIdGetValidateBeforeCall(Integer infoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'infoId' is set
        if (infoId == null) {
            throw new ApiException("Missing the required parameter 'infoId' when calling adminWatchInfoInfoIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = adminWatchInfoInfoIdGetCall(infoId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 查看系统信息
     * 
     * @param infoId info_id (required)
     * @return List&lt;SystemInfoPages&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<SystemInfoPages> adminWatchInfoInfoIdGet(Integer infoId) throws ApiException {
        ApiResponse<List<SystemInfoPages>> resp = adminWatchInfoInfoIdGetWithHttpInfo(infoId);
        return resp.getData();
    }

    /**
     * 查看系统信息
     * 
     * @param infoId info_id (required)
     * @return ApiResponse&lt;List&lt;SystemInfoPages&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<SystemInfoPages>> adminWatchInfoInfoIdGetWithHttpInfo(Integer infoId) throws ApiException {
        com.squareup.okhttp.Call call = adminWatchInfoInfoIdGetValidateBeforeCall(infoId, null, null);
        Type localVarReturnType = new TypeToken<List<SystemInfoPages>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 查看系统信息 (asynchronously)
     * 
     * @param infoId info_id (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call adminWatchInfoInfoIdGetAsync(Integer infoId, final ApiCallback<List<SystemInfoPages>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = adminWatchInfoInfoIdGetValidateBeforeCall(infoId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<SystemInfoPages>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
