/*
 * 柏九后端接口
 * ## 错误规则  ###    401 - 未登录，如果出现这个错误，请调用 登录/自动登录 接口刷新session或者requresttoken ###    403 - 权限不足， 一般不会出现这个错误 ###    417 - 碰到这个错误请将response的body解析为ErrorInfo一般情况是直接将ErrorInfo中的errorMessage 直接展现给用户 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package net.bojiu.android.io.swagger.api;

import net.bojiu.android.io.swagger.ApiCallback;
import net.bojiu.android.io.swagger.ApiClient;
import net.bojiu.android.io.swagger.ApiException;
import net.bojiu.android.io.swagger.ApiResponse;
import net.bojiu.android.io.swagger.Configuration;
import net.bojiu.android.io.swagger.Pair;
import net.bojiu.android.io.swagger.ProgressRequestBody;
import net.bojiu.android.io.swagger.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import net.bojiu.android.io.swagger.model.AutoLoginCredential;
import net.bojiu.android.io.swagger.model.LoginCredential;
import net.bojiu.android.io.swagger.model.VerifyTestResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AuthApi {
    private ApiClient apiClient;

    public AuthApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AuthApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for authUsersAutoLoginPost
     * @param autoLoginToken 用于自动登录的token (required)
     * @param machineId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authUsersAutoLoginPostCall(String autoLoginToken, String machineId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/auth/users/auto/login";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (autoLoginToken != null)
        localVarFormParams.put("autoLoginToken", autoLoginToken);
        if (machineId != null)
        localVarFormParams.put("machineId", machineId);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authUsersAutoLoginPostValidateBeforeCall(String autoLoginToken, String machineId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'autoLoginToken' is set
        if (autoLoginToken == null) {
            throw new ApiException("Missing the required parameter 'autoLoginToken' when calling authUsersAutoLoginPost(Async)");
        }
        
        // verify the required parameter 'machineId' is set
        if (machineId == null) {
            throw new ApiException("Missing the required parameter 'machineId' when calling authUsersAutoLoginPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authUsersAutoLoginPostCall(autoLoginToken, machineId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 自动登录/requstToken 刷新
     * 
     * @param autoLoginToken 用于自动登录的token (required)
     * @param machineId  (required)
     * @return AutoLoginCredential
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public AutoLoginCredential authUsersAutoLoginPost(String autoLoginToken, String machineId) throws ApiException {
        ApiResponse<AutoLoginCredential> resp = authUsersAutoLoginPostWithHttpInfo(autoLoginToken, machineId);
        return resp.getData();
    }

    /**
     * 自动登录/requstToken 刷新
     * 
     * @param autoLoginToken 用于自动登录的token (required)
     * @param machineId  (required)
     * @return ApiResponse&lt;AutoLoginCredential&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<AutoLoginCredential> authUsersAutoLoginPostWithHttpInfo(String autoLoginToken, String machineId) throws ApiException {
        com.squareup.okhttp.Call call = authUsersAutoLoginPostValidateBeforeCall(autoLoginToken, machineId, null, null);
        Type localVarReturnType = new TypeToken<AutoLoginCredential>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 自动登录/requstToken 刷新 (asynchronously)
     * 
     * @param autoLoginToken 用于自动登录的token (required)
     * @param machineId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authUsersAutoLoginPostAsync(String autoLoginToken, String machineId, final ApiCallback<AutoLoginCredential> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authUsersAutoLoginPostValidateBeforeCall(autoLoginToken, machineId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<AutoLoginCredential>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authUsersBindUserPhoneNumberPost
     * @param phoneNumber 用户绑定手机号 (required)
     * @param openId 用户唯一openid (required)
     * @param password 设置密码 (required)
     * @param verifyCode 验证码 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authUsersBindUserPhoneNumberPostCall(String phoneNumber, String openId, String password, String verifyCode, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/auth/users/bindUserPhoneNumber";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (phoneNumber != null)
        localVarFormParams.put("phoneNumber", phoneNumber);
        if (openId != null)
        localVarFormParams.put("openId", openId);
        if (password != null)
        localVarFormParams.put("password", password);
        if (verifyCode != null)
        localVarFormParams.put("verifyCode", verifyCode);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authUsersBindUserPhoneNumberPostValidateBeforeCall(String phoneNumber, String openId, String password, String verifyCode, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'phoneNumber' is set
        if (phoneNumber == null) {
            throw new ApiException("Missing the required parameter 'phoneNumber' when calling authUsersBindUserPhoneNumberPost(Async)");
        }
        
        // verify the required parameter 'openId' is set
        if (openId == null) {
            throw new ApiException("Missing the required parameter 'openId' when calling authUsersBindUserPhoneNumberPost(Async)");
        }
        
        // verify the required parameter 'password' is set
        if (password == null) {
            throw new ApiException("Missing the required parameter 'password' when calling authUsersBindUserPhoneNumberPost(Async)");
        }
        
        // verify the required parameter 'verifyCode' is set
        if (verifyCode == null) {
            throw new ApiException("Missing the required parameter 'verifyCode' when calling authUsersBindUserPhoneNumberPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authUsersBindUserPhoneNumberPostCall(phoneNumber, openId, password, verifyCode, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 第三方登录用户绑定手机号
     * 
     * @param phoneNumber 用户绑定手机号 (required)
     * @param openId 用户唯一openid (required)
     * @param password 设置密码 (required)
     * @param verifyCode 验证码 (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void authUsersBindUserPhoneNumberPost(String phoneNumber, String openId, String password, String verifyCode) throws ApiException {
        authUsersBindUserPhoneNumberPostWithHttpInfo(phoneNumber, openId, password, verifyCode);
    }

    /**
     * 第三方登录用户绑定手机号
     * 
     * @param phoneNumber 用户绑定手机号 (required)
     * @param openId 用户唯一openid (required)
     * @param password 设置密码 (required)
     * @param verifyCode 验证码 (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> authUsersBindUserPhoneNumberPostWithHttpInfo(String phoneNumber, String openId, String password, String verifyCode) throws ApiException {
        com.squareup.okhttp.Call call = authUsersBindUserPhoneNumberPostValidateBeforeCall(phoneNumber, openId, password, verifyCode, null, null);
        return apiClient.execute(call);
    }

    /**
     * 第三方登录用户绑定手机号 (asynchronously)
     * 
     * @param phoneNumber 用户绑定手机号 (required)
     * @param openId 用户唯一openid (required)
     * @param password 设置密码 (required)
     * @param verifyCode 验证码 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authUsersBindUserPhoneNumberPostAsync(String phoneNumber, String openId, String password, String verifyCode, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authUsersBindUserPhoneNumberPostValidateBeforeCall(phoneNumber, openId, password, verifyCode, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for authUsersLoginPost
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param machineId 机器号，没有可以为空 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authUsersLoginPostCall(String phone, String password, String machineId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/auth/users/login";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (phone != null)
        localVarFormParams.put("phone", phone);
        if (password != null)
        localVarFormParams.put("password", password);
        if (machineId != null)
        localVarFormParams.put("machineId", machineId);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authUsersLoginPostValidateBeforeCall(String phone, String password, String machineId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'phone' is set
        if (phone == null) {
            throw new ApiException("Missing the required parameter 'phone' when calling authUsersLoginPost(Async)");
        }
        
        // verify the required parameter 'password' is set
        if (password == null) {
            throw new ApiException("Missing the required parameter 'password' when calling authUsersLoginPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authUsersLoginPostCall(phone, password, machineId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 登录
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param machineId 机器号，没有可以为空 (optional)
     * @return LoginCredential
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public LoginCredential authUsersLoginPost(String phone, String password, String machineId) throws ApiException {
        ApiResponse<LoginCredential> resp = authUsersLoginPostWithHttpInfo(phone, password, machineId);
        return resp.getData();
    }

    /**
     * 登录
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param machineId 机器号，没有可以为空 (optional)
     * @return ApiResponse&lt;LoginCredential&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<LoginCredential> authUsersLoginPostWithHttpInfo(String phone, String password, String machineId) throws ApiException {
        com.squareup.okhttp.Call call = authUsersLoginPostValidateBeforeCall(phone, password, machineId, null, null);
        Type localVarReturnType = new TypeToken<LoginCredential>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 登录 (asynchronously)
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param machineId 机器号，没有可以为空 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authUsersLoginPostAsync(String phone, String password, String machineId, final ApiCallback<LoginCredential> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authUsersLoginPostValidateBeforeCall(phone, password, machineId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<LoginCredential>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authUsersRegisterOrLoginNonpartyPost
     * @param openId 用户唯一openid (required)
     * @param headImage 用户头像 (optional)
     * @param machineId 机器号，没有可以为空 (optional)
     * @param nickName 用户昵称 (optional)
     * @param loginModel 登录类型  QQ weichat weibo (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authUsersRegisterOrLoginNonpartyPostCall(String openId, String headImage, String machineId, String nickName, String loginModel, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/auth/users/registerOrLoginNonparty";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (headImage != null)
        localVarFormParams.put("headImage", headImage);
        if (openId != null)
        localVarFormParams.put("openId", openId);
        if (machineId != null)
        localVarFormParams.put("machineId", machineId);
        if (nickName != null)
        localVarFormParams.put("nickName", nickName);
        if (loginModel != null)
        localVarFormParams.put("loginModel", loginModel);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authUsersRegisterOrLoginNonpartyPostValidateBeforeCall(String openId, String headImage, String machineId, String nickName, String loginModel, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'openId' is set
        if (openId == null) {
            throw new ApiException("Missing the required parameter 'openId' when calling authUsersRegisterOrLoginNonpartyPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authUsersRegisterOrLoginNonpartyPostCall(openId, headImage, machineId, nickName, loginModel, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 第三方登录注册接口
     * 
     * @param openId 用户唯一openid (required)
     * @param headImage 用户头像 (optional)
     * @param machineId 机器号，没有可以为空 (optional)
     * @param nickName 用户昵称 (optional)
     * @param loginModel 登录类型  QQ weichat weibo (optional)
     * @return LoginCredential
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public LoginCredential authUsersRegisterOrLoginNonpartyPost(String openId, String headImage, String machineId, String nickName, String loginModel) throws ApiException {
        ApiResponse<LoginCredential> resp = authUsersRegisterOrLoginNonpartyPostWithHttpInfo(openId, headImage, machineId, nickName, loginModel);
        return resp.getData();
    }

    /**
     * 第三方登录注册接口
     * 
     * @param openId 用户唯一openid (required)
     * @param headImage 用户头像 (optional)
     * @param machineId 机器号，没有可以为空 (optional)
     * @param nickName 用户昵称 (optional)
     * @param loginModel 登录类型  QQ weichat weibo (optional)
     * @return ApiResponse&lt;LoginCredential&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<LoginCredential> authUsersRegisterOrLoginNonpartyPostWithHttpInfo(String openId, String headImage, String machineId, String nickName, String loginModel) throws ApiException {
        com.squareup.okhttp.Call call = authUsersRegisterOrLoginNonpartyPostValidateBeforeCall(openId, headImage, machineId, nickName, loginModel, null, null);
        Type localVarReturnType = new TypeToken<LoginCredential>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 第三方登录注册接口 (asynchronously)
     * 
     * @param openId 用户唯一openid (required)
     * @param headImage 用户头像 (optional)
     * @param machineId 机器号，没有可以为空 (optional)
     * @param nickName 用户昵称 (optional)
     * @param loginModel 登录类型  QQ weichat weibo (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authUsersRegisterOrLoginNonpartyPostAsync(String openId, String headImage, String machineId, String nickName, String loginModel, final ApiCallback<LoginCredential> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authUsersRegisterOrLoginNonpartyPostValidateBeforeCall(openId, headImage, machineId, nickName, loginModel, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<LoginCredential>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authUsersRegisterPost
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @param machineId 机器号，没有可以为空 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authUsersRegisterPostCall(String phone, String password, String textCode, String machineId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/auth/users/register";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (phone != null)
        localVarFormParams.put("phone", phone);
        if (password != null)
        localVarFormParams.put("password", password);
        if (machineId != null)
        localVarFormParams.put("machineId", machineId);
        if (textCode != null)
        localVarFormParams.put("textCode", textCode);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authUsersRegisterPostValidateBeforeCall(String phone, String password, String textCode, String machineId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'phone' is set
        if (phone == null) {
            throw new ApiException("Missing the required parameter 'phone' when calling authUsersRegisterPost(Async)");
        }
        
        // verify the required parameter 'password' is set
        if (password == null) {
            throw new ApiException("Missing the required parameter 'password' when calling authUsersRegisterPost(Async)");
        }
        
        // verify the required parameter 'textCode' is set
        if (textCode == null) {
            throw new ApiException("Missing the required parameter 'textCode' when calling authUsersRegisterPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authUsersRegisterPostCall(phone, password, textCode, machineId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 注册接口
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @param machineId 机器号，没有可以为空 (optional)
     * @return LoginCredential
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public LoginCredential authUsersRegisterPost(String phone, String password, String textCode, String machineId) throws ApiException {
        ApiResponse<LoginCredential> resp = authUsersRegisterPostWithHttpInfo(phone, password, textCode, machineId);
        return resp.getData();
    }

    /**
     * 注册接口
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @param machineId 机器号，没有可以为空 (optional)
     * @return ApiResponse&lt;LoginCredential&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<LoginCredential> authUsersRegisterPostWithHttpInfo(String phone, String password, String textCode, String machineId) throws ApiException {
        com.squareup.okhttp.Call call = authUsersRegisterPostValidateBeforeCall(phone, password, textCode, machineId, null, null);
        Type localVarReturnType = new TypeToken<LoginCredential>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 注册接口 (asynchronously)
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @param machineId 机器号，没有可以为空 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authUsersRegisterPostAsync(String phone, String password, String textCode, String machineId, final ApiCallback<LoginCredential> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authUsersRegisterPostValidateBeforeCall(phone, password, textCode, machineId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<LoginCredential>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authUsersResetPasswordPost
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authUsersResetPasswordPostCall(String phone, String password, String textCode, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/auth/users/resetPassword";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (phone != null)
        localVarFormParams.put("phone", phone);
        if (password != null)
        localVarFormParams.put("password", password);
        if (textCode != null)
        localVarFormParams.put("textCode", textCode);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authUsersResetPasswordPostValidateBeforeCall(String phone, String password, String textCode, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'phone' is set
        if (phone == null) {
            throw new ApiException("Missing the required parameter 'phone' when calling authUsersResetPasswordPost(Async)");
        }
        
        // verify the required parameter 'password' is set
        if (password == null) {
            throw new ApiException("Missing the required parameter 'password' when calling authUsersResetPasswordPost(Async)");
        }
        
        // verify the required parameter 'textCode' is set
        if (textCode == null) {
            throw new ApiException("Missing the required parameter 'textCode' when calling authUsersResetPasswordPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authUsersResetPasswordPostCall(phone, password, textCode, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 找回更新密码
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void authUsersResetPasswordPost(String phone, String password, String textCode) throws ApiException {
        authUsersResetPasswordPostWithHttpInfo(phone, password, textCode);
    }

    /**
     * 找回更新密码
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> authUsersResetPasswordPostWithHttpInfo(String phone, String password, String textCode) throws ApiException {
        com.squareup.okhttp.Call call = authUsersResetPasswordPostValidateBeforeCall(phone, password, textCode, null, null);
        return apiClient.execute(call);
    }

    /**
     * 找回更新密码 (asynchronously)
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authUsersResetPasswordPostAsync(String phone, String password, String textCode, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authUsersResetPasswordPostValidateBeforeCall(phone, password, textCode, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for authUsersVerifyTextPost
     * @param phone 手机号 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authUsersVerifyTextPostCall(String phone, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/auth/users/VerifyText";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (phone != null)
        localVarFormParams.put("phone", phone);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authUsersVerifyTextPostValidateBeforeCall(String phone, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'phone' is set
        if (phone == null) {
            throw new ApiException("Missing the required parameter 'phone' when calling authUsersVerifyTextPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authUsersVerifyTextPostCall(phone, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取登录验证码
     * 
     * @param phone 手机号 (required)
     * @return VerifyTestResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public VerifyTestResponse authUsersVerifyTextPost(String phone) throws ApiException {
        ApiResponse<VerifyTestResponse> resp = authUsersVerifyTextPostWithHttpInfo(phone);
        return resp.getData();
    }

    /**
     * 获取登录验证码
     * 
     * @param phone 手机号 (required)
     * @return ApiResponse&lt;VerifyTestResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<VerifyTestResponse> authUsersVerifyTextPostWithHttpInfo(String phone) throws ApiException {
        com.squareup.okhttp.Call call = authUsersVerifyTextPostValidateBeforeCall(phone, null, null);
        Type localVarReturnType = new TypeToken<VerifyTestResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取登录验证码 (asynchronously)
     * 
     * @param phone 手机号 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authUsersVerifyTextPostAsync(String phone, final ApiCallback<VerifyTestResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authUsersVerifyTextPostValidateBeforeCall(phone, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<VerifyTestResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
