/*
 * 柏九后端接口
 * ## 错误规则  ###    401 - 未登录，如果出现这个错误，请调用 登录/自动登录 接口刷新session或者requresttoken ###    403 - 权限不足， 一般不会出现这个错误 ###    417 - 碰到这个错误请将response的body解析为ErrorInfo一般情况是直接将ErrorInfo中的errorMessage 直接展现给用户 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package net.bojiu.android.io.swagger.api;

import net.bojiu.android.io.swagger.ApiCallback;
import net.bojiu.android.io.swagger.ApiClient;
import net.bojiu.android.io.swagger.ApiException;
import net.bojiu.android.io.swagger.ApiResponse;
import net.bojiu.android.io.swagger.Configuration;
import net.bojiu.android.io.swagger.Pair;
import net.bojiu.android.io.swagger.ProgressRequestBody;
import net.bojiu.android.io.swagger.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import net.bojiu.android.io.swagger.model.AuthorAuthInfo;
import net.bojiu.android.io.swagger.model.AuthorInfo;
import net.bojiu.android.io.swagger.model.FansInfo;
import net.bojiu.android.io.swagger.model.FollowUserInfo;
import net.bojiu.android.io.swagger.model.ProductionDetail;
import net.bojiu.android.io.swagger.model.ProductionIdAndVideoId;
import net.bojiu.android.io.swagger.model.ProductionUpload;
import net.bojiu.android.io.swagger.model.Tag;
import net.bojiu.android.io.swagger.model.VideoInfo;
import net.bojiu.android.io.swagger.model.VideoUploadAuth;
import net.bojiu.android.io.swagger.model.VideoUploadRefreshAuth;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AuthorApi {
    private ApiClient apiClient;

    public AuthorApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AuthorApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for authAuthorsAuthInfoGet
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authAuthorsAuthInfoGetCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/auth/authors/authInfo";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authAuthorsAuthInfoGetValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = authAuthorsAuthInfoGetCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取自己的认证信息
     * 
     * @return AuthorAuthInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public AuthorAuthInfo authAuthorsAuthInfoGet() throws ApiException {
        ApiResponse<AuthorAuthInfo> resp = authAuthorsAuthInfoGetWithHttpInfo();
        return resp.getData();
    }

    /**
     * 获取自己的认证信息
     * 
     * @return ApiResponse&lt;AuthorAuthInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<AuthorAuthInfo> authAuthorsAuthInfoGetWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = authAuthorsAuthInfoGetValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<AuthorAuthInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取自己的认证信息 (asynchronously)
     * 
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authAuthorsAuthInfoGetAsync(final ApiCallback<AuthorAuthInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authAuthorsAuthInfoGetValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<AuthorAuthInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authAuthorsAuthInfoPost
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authAuthorsAuthInfoPostCall(AuthorAuthInfo authorInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = authorInfo;
        
        // create path and map variables
        String localVarPath = "/auth/authors/authInfo";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authAuthorsAuthInfoPostValidateBeforeCall(AuthorAuthInfo authorInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorInfo' is set
        if (authorInfo == null) {
            throw new ApiException("Missing the required parameter 'authorInfo' when calling authAuthorsAuthInfoPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authAuthorsAuthInfoPostCall(authorInfo, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 修改自己的个人认证信息
     * 
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void authAuthorsAuthInfoPost(AuthorAuthInfo authorInfo) throws ApiException {
        authAuthorsAuthInfoPostWithHttpInfo(authorInfo);
    }

    /**
     * 修改自己的个人认证信息
     * 
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> authAuthorsAuthInfoPostWithHttpInfo(AuthorAuthInfo authorInfo) throws ApiException {
        com.squareup.okhttp.Call call = authAuthorsAuthInfoPostValidateBeforeCall(authorInfo, null, null);
        return apiClient.execute(call);
    }

    /**
     * 修改自己的个人认证信息 (asynchronously)
     * 
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authAuthorsAuthInfoPostAsync(AuthorAuthInfo authorInfo, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authAuthorsAuthInfoPostValidateBeforeCall(authorInfo, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for authorAuthorsAuthorIdGetFansInfoGet
     * @param authorId 授权号id (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorAuthorsAuthorIdGetFansInfoGetCall(Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/author/authors/{authorId}/getFansInfo"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorAuthorsAuthorIdGetFansInfoGetValidateBeforeCall(Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling authorAuthorsAuthorIdGetFansInfoGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorAuthorsAuthorIdGetFansInfoGetCall(authorId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取授权号粉丝信息（id name machine_type）
     * 
     * @param authorId 授权号id (required)
     * @return List&lt;FansInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<FansInfo> authorAuthorsAuthorIdGetFansInfoGet(Integer authorId) throws ApiException {
        ApiResponse<List<FansInfo>> resp = authorAuthorsAuthorIdGetFansInfoGetWithHttpInfo(authorId);
        return resp.getData();
    }

    /**
     * 获取授权号粉丝信息（id name machine_type）
     * 
     * @param authorId 授权号id (required)
     * @return ApiResponse&lt;List&lt;FansInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<FansInfo>> authorAuthorsAuthorIdGetFansInfoGetWithHttpInfo(Integer authorId) throws ApiException {
        com.squareup.okhttp.Call call = authorAuthorsAuthorIdGetFansInfoGetValidateBeforeCall(authorId, null, null);
        Type localVarReturnType = new TypeToken<List<FansInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取授权号粉丝信息（id name machine_type） (asynchronously)
     * 
     * @param authorId 授权号id (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorAuthorsAuthorIdGetFansInfoGetAsync(Integer authorId, final ApiCallback<List<FansInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorAuthorsAuthorIdGetFansInfoGetValidateBeforeCall(authorId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<FansInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authorAuthorsAuthorIdProductionsGet
     * @param authorId  (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorAuthorsAuthorIdProductionsGetCall(Integer authorId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/author/authors/{authorId}/productions"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorAuthorsAuthorIdProductionsGetValidateBeforeCall(Integer authorId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling authorAuthorsAuthorIdProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling authorAuthorsAuthorIdProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling authorAuthorsAuthorIdProductionsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorAuthorsAuthorIdProductionsGetCall(authorId, pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取这个作者的所有作品接口，包括没有认证和没有上架的
     * 
     * @param authorId  (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionDetail> authorAuthorsAuthorIdProductionsGet(Integer authorId, Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<ProductionDetail>> resp = authorAuthorsAuthorIdProductionsGetWithHttpInfo(authorId, pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取这个作者的所有作品接口，包括没有认证和没有上架的
     * 
     * @param authorId  (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;ProductionDetail&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionDetail>> authorAuthorsAuthorIdProductionsGetWithHttpInfo(Integer authorId, Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = authorAuthorsAuthorIdProductionsGetValidateBeforeCall(authorId, pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取这个作者的所有作品接口，包括没有认证和没有上架的 (asynchronously)
     * 
     * @param authorId  (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorAuthorsAuthorIdProductionsGetAsync(Integer authorId, Integer pageNum, Integer pageSize, final ApiCallback<List<ProductionDetail>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorAuthorsAuthorIdProductionsGetValidateBeforeCall(authorId, pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authorFollowsGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorFollowsGetCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/author/follows";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorFollowsGetValidateBeforeCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling authorFollowsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling authorFollowsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorFollowsGetCall(pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取自己的被关注用户列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;FollowUserInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<FollowUserInfo> authorFollowsGet(Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<FollowUserInfo>> resp = authorFollowsGetWithHttpInfo(pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取自己的被关注用户列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;FollowUserInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<FollowUserInfo>> authorFollowsGetWithHttpInfo(Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = authorFollowsGetValidateBeforeCall(pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<FollowUserInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取自己的被关注用户列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorFollowsGetAsync(Integer pageNum, Integer pageSize, final ApiCallback<List<FollowUserInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorFollowsGetValidateBeforeCall(pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<FollowUserInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authorInfoPost
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorInfoPostCall(AuthorInfo authorInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = authorInfo;
        
        // create path and map variables
        String localVarPath = "/author/info";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorInfoPostValidateBeforeCall(AuthorInfo authorInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorInfo' is set
        if (authorInfo == null) {
            throw new ApiException("Missing the required parameter 'authorInfo' when calling authorInfoPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorInfoPostCall(authorInfo, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 修改自己的个人信息
     * 
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void authorInfoPost(AuthorInfo authorInfo) throws ApiException {
        authorInfoPostWithHttpInfo(authorInfo);
    }

    /**
     * 修改自己的个人信息
     * 
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> authorInfoPostWithHttpInfo(AuthorInfo authorInfo) throws ApiException {
        com.squareup.okhttp.Call call = authorInfoPostValidateBeforeCall(authorInfo, null, null);
        return apiClient.execute(call);
    }

    /**
     * 修改自己的个人信息 (asynchronously)
     * 
     * @param authorInfo 不需要修改的字段直接传null (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorInfoPostAsync(AuthorInfo authorInfo, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorInfoPostValidateBeforeCall(authorInfo, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for authorProductionsPost
     * @param production  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorProductionsPostCall(ProductionUpload production, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = production;
        
        // create path and map variables
        String localVarPath = "/author/productions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorProductionsPostValidateBeforeCall(ProductionUpload production, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'production' is set
        if (production == null) {
            throw new ApiException("Missing the required parameter 'production' when calling authorProductionsPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorProductionsPostCall(production, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 作品创建接口
     * 
     * @param production  (required)
     * @return ProductionIdAndVideoId
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProductionIdAndVideoId authorProductionsPost(ProductionUpload production) throws ApiException {
        ApiResponse<ProductionIdAndVideoId> resp = authorProductionsPostWithHttpInfo(production);
        return resp.getData();
    }

    /**
     * 作品创建接口
     * 
     * @param production  (required)
     * @return ApiResponse&lt;ProductionIdAndVideoId&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProductionIdAndVideoId> authorProductionsPostWithHttpInfo(ProductionUpload production) throws ApiException {
        com.squareup.okhttp.Call call = authorProductionsPostValidateBeforeCall(production, null, null);
        Type localVarReturnType = new TypeToken<ProductionIdAndVideoId>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 作品创建接口 (asynchronously)
     * 
     * @param production  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorProductionsPostAsync(ProductionUpload production, final ApiCallback<ProductionIdAndVideoId> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorProductionsPostValidateBeforeCall(production, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProductionIdAndVideoId>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authorProductionsProductionIdDelete
     * @param productionId 作品ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorProductionsProductionIdDeleteCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/author/productions/{productionId}"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorProductionsProductionIdDeleteValidateBeforeCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling authorProductionsProductionIdDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorProductionsProductionIdDeleteCall(productionId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 删除某个作品
     * 
     * @param productionId 作品ID (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void authorProductionsProductionIdDelete(Integer productionId) throws ApiException {
        authorProductionsProductionIdDeleteWithHttpInfo(productionId);
    }

    /**
     * 删除某个作品
     * 
     * @param productionId 作品ID (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> authorProductionsProductionIdDeleteWithHttpInfo(Integer productionId) throws ApiException {
        com.squareup.okhttp.Call call = authorProductionsProductionIdDeleteValidateBeforeCall(productionId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 删除某个作品 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorProductionsProductionIdDeleteAsync(Integer productionId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorProductionsProductionIdDeleteValidateBeforeCall(productionId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for authorProductionsProductionIdPost
     * @param production  (required)
     * @param productionId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorProductionsProductionIdPostCall(ProductionUpload production, Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = production;
        
        // create path and map variables
        String localVarPath = "/author/productions/{productionId}"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorProductionsProductionIdPostValidateBeforeCall(ProductionUpload production, Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'production' is set
        if (production == null) {
            throw new ApiException("Missing the required parameter 'production' when calling authorProductionsProductionIdPost(Async)");
        }
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling authorProductionsProductionIdPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorProductionsProductionIdPostCall(production, productionId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 修改某个作品
     * 
     * @param production  (required)
     * @param productionId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void authorProductionsProductionIdPost(ProductionUpload production, Integer productionId) throws ApiException {
        authorProductionsProductionIdPostWithHttpInfo(production, productionId);
    }

    /**
     * 修改某个作品
     * 
     * @param production  (required)
     * @param productionId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> authorProductionsProductionIdPostWithHttpInfo(ProductionUpload production, Integer productionId) throws ApiException {
        com.squareup.okhttp.Call call = authorProductionsProductionIdPostValidateBeforeCall(production, productionId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 修改某个作品 (asynchronously)
     * 
     * @param production  (required)
     * @param productionId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorProductionsProductionIdPostAsync(ProductionUpload production, Integer productionId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorProductionsProductionIdPostValidateBeforeCall(production, productionId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for authorProductionsProductionIdSubmitDelete
     * @param productionId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorProductionsProductionIdSubmitDeleteCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/author/productions/{productionId}/submit"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorProductionsProductionIdSubmitDeleteValidateBeforeCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling authorProductionsProductionIdSubmitDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorProductionsProductionIdSubmitDeleteCall(productionId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 撤销提交（已经审核通过的不能撤销）
     * 
     * @param productionId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void authorProductionsProductionIdSubmitDelete(Integer productionId) throws ApiException {
        authorProductionsProductionIdSubmitDeleteWithHttpInfo(productionId);
    }

    /**
     * 撤销提交（已经审核通过的不能撤销）
     * 
     * @param productionId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> authorProductionsProductionIdSubmitDeleteWithHttpInfo(Integer productionId) throws ApiException {
        com.squareup.okhttp.Call call = authorProductionsProductionIdSubmitDeleteValidateBeforeCall(productionId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 撤销提交（已经审核通过的不能撤销） (asynchronously)
     * 
     * @param productionId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorProductionsProductionIdSubmitDeleteAsync(Integer productionId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorProductionsProductionIdSubmitDeleteValidateBeforeCall(productionId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for authorProductionsProductionIdSubmitPost
     * @param productionId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorProductionsProductionIdSubmitPostCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/author/productions/{productionId}/submit"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorProductionsProductionIdSubmitPostValidateBeforeCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling authorProductionsProductionIdSubmitPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorProductionsProductionIdSubmitPostCall(productionId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 提交认证某个作品
     * 
     * @param productionId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void authorProductionsProductionIdSubmitPost(Integer productionId) throws ApiException {
        authorProductionsProductionIdSubmitPostWithHttpInfo(productionId);
    }

    /**
     * 提交认证某个作品
     * 
     * @param productionId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> authorProductionsProductionIdSubmitPostWithHttpInfo(Integer productionId) throws ApiException {
        com.squareup.okhttp.Call call = authorProductionsProductionIdSubmitPostValidateBeforeCall(productionId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 提交认证某个作品 (asynchronously)
     * 
     * @param productionId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorProductionsProductionIdSubmitPostAsync(Integer productionId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorProductionsProductionIdSubmitPostValidateBeforeCall(productionId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for authorRefreshVideoAuthPost
     * @param videoId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorRefreshVideoAuthPostCall(String videoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/author/refreshVideoAuth";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (videoId != null)
        localVarFormParams.put("videoId", videoId);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorRefreshVideoAuthPostValidateBeforeCall(String videoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'videoId' is set
        if (videoId == null) {
            throw new ApiException("Missing the required parameter 'videoId' when calling authorRefreshVideoAuthPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorRefreshVideoAuthPostCall(videoId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 刷新上传凭证
     * 
     * @param videoId  (required)
     * @return VideoUploadRefreshAuth
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public VideoUploadRefreshAuth authorRefreshVideoAuthPost(String videoId) throws ApiException {
        ApiResponse<VideoUploadRefreshAuth> resp = authorRefreshVideoAuthPostWithHttpInfo(videoId);
        return resp.getData();
    }

    /**
     * 刷新上传凭证
     * 
     * @param videoId  (required)
     * @return ApiResponse&lt;VideoUploadRefreshAuth&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<VideoUploadRefreshAuth> authorRefreshVideoAuthPostWithHttpInfo(String videoId) throws ApiException {
        com.squareup.okhttp.Call call = authorRefreshVideoAuthPostValidateBeforeCall(videoId, null, null);
        Type localVarReturnType = new TypeToken<VideoUploadRefreshAuth>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 刷新上传凭证 (asynchronously)
     * 
     * @param videoId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorRefreshVideoAuthPostAsync(String videoId, final ApiCallback<VideoUploadRefreshAuth> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorRefreshVideoAuthPostValidateBeforeCall(videoId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<VideoUploadRefreshAuth>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authorTagsPost
     * @param tag  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorTagsPostCall(Tag tag, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = tag;
        
        // create path and map variables
        String localVarPath = "/author/tags";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorTagsPostValidateBeforeCall(Tag tag, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tag' is set
        if (tag == null) {
            throw new ApiException("Missing the required parameter 'tag' when calling authorTagsPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorTagsPostCall(tag, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Author创建关键词
     * 
     * @param tag  (required)
     * @return Integer
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Integer authorTagsPost(Tag tag) throws ApiException {
        ApiResponse<Integer> resp = authorTagsPostWithHttpInfo(tag);
        return resp.getData();
    }

    /**
     * Author创建关键词
     * 
     * @param tag  (required)
     * @return ApiResponse&lt;Integer&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Integer> authorTagsPostWithHttpInfo(Tag tag) throws ApiException {
        com.squareup.okhttp.Call call = authorTagsPostValidateBeforeCall(tag, null, null);
        Type localVarReturnType = new TypeToken<Integer>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Author创建关键词 (asynchronously)
     * 
     * @param tag  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorTagsPostAsync(Tag tag, final ApiCallback<Integer> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorTagsPostValidateBeforeCall(tag, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Integer>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for authorUploadVideoAuthPost
     * @param videoInfo  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call authorUploadVideoAuthPostCall(VideoInfo videoInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = videoInfo;
        
        // create path and map variables
        String localVarPath = "/author/uploadVideoAuth";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call authorUploadVideoAuthPostValidateBeforeCall(VideoInfo videoInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'videoInfo' is set
        if (videoInfo == null) {
            throw new ApiException("Missing the required parameter 'videoInfo' when calling authorUploadVideoAuthPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = authorUploadVideoAuthPostCall(videoInfo, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取上传凭证
     * 
     * @param videoInfo  (required)
     * @return VideoUploadAuth
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public VideoUploadAuth authorUploadVideoAuthPost(VideoInfo videoInfo) throws ApiException {
        ApiResponse<VideoUploadAuth> resp = authorUploadVideoAuthPostWithHttpInfo(videoInfo);
        return resp.getData();
    }

    /**
     * 获取上传凭证
     * 
     * @param videoInfo  (required)
     * @return ApiResponse&lt;VideoUploadAuth&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<VideoUploadAuth> authorUploadVideoAuthPostWithHttpInfo(VideoInfo videoInfo) throws ApiException {
        com.squareup.okhttp.Call call = authorUploadVideoAuthPostValidateBeforeCall(videoInfo, null, null);
        Type localVarReturnType = new TypeToken<VideoUploadAuth>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取上传凭证 (asynchronously)
     * 
     * @param videoInfo  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call authorUploadVideoAuthPostAsync(VideoInfo videoInfo, final ApiCallback<VideoUploadAuth> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = authorUploadVideoAuthPostValidateBeforeCall(videoInfo, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<VideoUploadAuth>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
