/*
 * 柏九后端接口
 * ## 错误规则  ###    401 - 未登录，如果出现这个错误，请调用 登录/自动登录 接口刷新session或者requresttoken ###    403 - 权限不足， 一般不会出现这个错误 ###    417 - 碰到这个错误请将response的body解析为ErrorInfo一般情况是直接将ErrorInfo中的errorMessage 直接展现给用户 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package net.bojiu.android.io.swagger.api;

import net.bojiu.android.io.swagger.ApiCallback;
import net.bojiu.android.io.swagger.ApiClient;
import net.bojiu.android.io.swagger.ApiException;
import net.bojiu.android.io.swagger.ApiResponse;
import net.bojiu.android.io.swagger.Configuration;
import net.bojiu.android.io.swagger.Pair;
import net.bojiu.android.io.swagger.ProgressRequestBody;
import net.bojiu.android.io.swagger.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import net.bojiu.android.io.swagger.model.AuthorInfo;
import net.bojiu.android.io.swagger.model.Barrage;
import net.bojiu.android.io.swagger.model.Cluster;
import net.bojiu.android.io.swagger.model.OSSCredential;
import net.bojiu.android.io.swagger.model.OssUrl;
import net.bojiu.android.io.swagger.model.ProductionComment;
import net.bojiu.android.io.swagger.model.ProductionCommentReply;
import net.bojiu.android.io.swagger.model.ProductionDetail;
import net.bojiu.android.io.swagger.model.ReturnBarrageInfo;
import net.bojiu.android.io.swagger.model.Tag;
import net.bojiu.android.io.swagger.model.VideoPlayAuth;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NormalApi {
    private ApiClient apiClient;

    public NormalApi() {
        this(Configuration.getDefaultApiClient());
    }

    public NormalApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for normalAddUserPlayCountsPost
     * @param machineType  (optional)
     * @param videoId  (optional)
     * @param durationTime  (optional)
     * @param userId 用户id (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalAddUserPlayCountsPostCall(String machineType, String videoId, String durationTime, Integer userId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/addUserPlayCounts";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (machineType != null)
        localVarFormParams.put("machineType", machineType);
        if (videoId != null)
        localVarFormParams.put("videoId", videoId);
        if (durationTime != null)
        localVarFormParams.put("durationTime", durationTime);
        if (userId != null)
        localVarFormParams.put("userId", userId);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalAddUserPlayCountsPostValidateBeforeCall(String machineType, String videoId, String durationTime, Integer userId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = normalAddUserPlayCountsPostCall(machineType, videoId, durationTime, userId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 添加用户播放次数[按照客户端维度统计]
     * 
     * @param machineType  (optional)
     * @param videoId  (optional)
     * @param durationTime  (optional)
     * @param userId 用户id (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void normalAddUserPlayCountsPost(String machineType, String videoId, String durationTime, Integer userId) throws ApiException {
        normalAddUserPlayCountsPostWithHttpInfo(machineType, videoId, durationTime, userId);
    }

    /**
     * 添加用户播放次数[按照客户端维度统计]
     * 
     * @param machineType  (optional)
     * @param videoId  (optional)
     * @param durationTime  (optional)
     * @param userId 用户id (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> normalAddUserPlayCountsPostWithHttpInfo(String machineType, String videoId, String durationTime, Integer userId) throws ApiException {
        com.squareup.okhttp.Call call = normalAddUserPlayCountsPostValidateBeforeCall(machineType, videoId, durationTime, userId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 添加用户播放次数[按照客户端维度统计] (asynchronously)
     * 
     * @param machineType  (optional)
     * @param videoId  (optional)
     * @param durationTime  (optional)
     * @param userId 用户id (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalAddUserPlayCountsPostAsync(String machineType, String videoId, String durationTime, Integer userId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalAddUserPlayCountsPostValidateBeforeCall(machineType, videoId, durationTime, userId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for normalAuthorsAuthorIdProductionsGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authorId author&#39;s ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalAuthorsAuthorIdProductionsGetCall(Integer pageNum, Integer pageSize, Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/authors/{authorId}/productions"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalAuthorsAuthorIdProductionsGetValidateBeforeCall(Integer pageNum, Integer pageSize, Integer authorId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalAuthorsAuthorIdProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalAuthorsAuthorIdProductionsGet(Async)");
        }
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling normalAuthorsAuthorIdProductionsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalAuthorsAuthorIdProductionsGetCall(pageNum, pageSize, authorId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 授权号的作品列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authorId author&#39;s ID (required)
     * @return List&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionDetail> normalAuthorsAuthorIdProductionsGet(Integer pageNum, Integer pageSize, Integer authorId) throws ApiException {
        ApiResponse<List<ProductionDetail>> resp = normalAuthorsAuthorIdProductionsGetWithHttpInfo(pageNum, pageSize, authorId);
        return resp.getData();
    }

    /**
     * 授权号的作品列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authorId author&#39;s ID (required)
     * @return ApiResponse&lt;List&lt;ProductionDetail&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionDetail>> normalAuthorsAuthorIdProductionsGetWithHttpInfo(Integer pageNum, Integer pageSize, Integer authorId) throws ApiException {
        com.squareup.okhttp.Call call = normalAuthorsAuthorIdProductionsGetValidateBeforeCall(pageNum, pageSize, authorId, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 授权号的作品列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param authorId author&#39;s ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalAuthorsAuthorIdProductionsGetAsync(Integer pageNum, Integer pageSize, Integer authorId, final ApiCallback<List<ProductionDetail>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalAuthorsAuthorIdProductionsGetValidateBeforeCall(pageNum, pageSize, authorId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalAuthorsFoundGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalAuthorsFoundGetCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/authors/found";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalAuthorsFoundGetValidateBeforeCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalAuthorsFoundGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalAuthorsFoundGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalAuthorsFoundGetCall(pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 发现列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;AuthorInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<AuthorInfo> normalAuthorsFoundGet(Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<AuthorInfo>> resp = normalAuthorsFoundGetWithHttpInfo(pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 发现列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;AuthorInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<AuthorInfo>> normalAuthorsFoundGetWithHttpInfo(Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalAuthorsFoundGetValidateBeforeCall(pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 发现列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalAuthorsFoundGetAsync(Integer pageNum, Integer pageSize, final ApiCallback<List<AuthorInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalAuthorsFoundGetValidateBeforeCall(pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalBarragePost
     * @param barrageInfo 创建弹幕信息 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalBarragePostCall(Barrage barrageInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = barrageInfo;
        
        // create path and map variables
        String localVarPath = "/normal/barrage";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalBarragePostValidateBeforeCall(Barrage barrageInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'barrageInfo' is set
        if (barrageInfo == null) {
            throw new ApiException("Missing the required parameter 'barrageInfo' when calling normalBarragePost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalBarragePostCall(barrageInfo, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 创建弹幕
     * 
     * @param barrageInfo 创建弹幕信息 (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String normalBarragePost(Barrage barrageInfo) throws ApiException {
        ApiResponse<String> resp = normalBarragePostWithHttpInfo(barrageInfo);
        return resp.getData();
    }

    /**
     * 创建弹幕
     * 
     * @param barrageInfo 创建弹幕信息 (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> normalBarragePostWithHttpInfo(Barrage barrageInfo) throws ApiException {
        com.squareup.okhttp.Call call = normalBarragePostValidateBeforeCall(barrageInfo, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 创建弹幕 (asynchronously)
     * 
     * @param barrageInfo 创建弹幕信息 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalBarragePostAsync(Barrage barrageInfo, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalBarragePostValidateBeforeCall(barrageInfo, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalClustersClusterIdGet
     * @param clusterId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalClustersClusterIdGetCall(Integer clusterId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/clusters/{clusterId}"
            .replaceAll("\\{" + "clusterId" + "\\}", apiClient.escapeString(clusterId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalClustersClusterIdGetValidateBeforeCall(Integer clusterId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterId' is set
        if (clusterId == null) {
            throw new ApiException("Missing the required parameter 'clusterId' when calling normalClustersClusterIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalClustersClusterIdGetCall(clusterId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取某个分类的信息
     * 
     * @param clusterId  (required)
     * @return Cluster
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Cluster normalClustersClusterIdGet(Integer clusterId) throws ApiException {
        ApiResponse<Cluster> resp = normalClustersClusterIdGetWithHttpInfo(clusterId);
        return resp.getData();
    }

    /**
     * 获取某个分类的信息
     * 
     * @param clusterId  (required)
     * @return ApiResponse&lt;Cluster&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Cluster> normalClustersClusterIdGetWithHttpInfo(Integer clusterId) throws ApiException {
        com.squareup.okhttp.Call call = normalClustersClusterIdGetValidateBeforeCall(clusterId, null, null);
        Type localVarReturnType = new TypeToken<Cluster>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取某个分类的信息 (asynchronously)
     * 
     * @param clusterId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalClustersClusterIdGetAsync(Integer clusterId, final ApiCallback<Cluster> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalClustersClusterIdGetValidateBeforeCall(clusterId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Cluster>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalClustersClusterIdProductionsGet
     * @param clusterId 分类的ID (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalClustersClusterIdProductionsGetCall(Integer clusterId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/clusters/{clusterId}/productions"
            .replaceAll("\\{" + "clusterId" + "\\}", apiClient.escapeString(clusterId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalClustersClusterIdProductionsGetValidateBeforeCall(Integer clusterId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'clusterId' is set
        if (clusterId == null) {
            throw new ApiException("Missing the required parameter 'clusterId' when calling normalClustersClusterIdProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalClustersClusterIdProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalClustersClusterIdProductionsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalClustersClusterIdProductionsGetCall(clusterId, pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取某个分类下的产品列表
     * 
     * @param clusterId 分类的ID (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionDetail> normalClustersClusterIdProductionsGet(Integer clusterId, Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<ProductionDetail>> resp = normalClustersClusterIdProductionsGetWithHttpInfo(clusterId, pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取某个分类下的产品列表
     * 
     * @param clusterId 分类的ID (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;ProductionDetail&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionDetail>> normalClustersClusterIdProductionsGetWithHttpInfo(Integer clusterId, Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalClustersClusterIdProductionsGetValidateBeforeCall(clusterId, pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取某个分类下的产品列表 (asynchronously)
     * 
     * @param clusterId 分类的ID (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalClustersClusterIdProductionsGetAsync(Integer clusterId, Integer pageNum, Integer pageSize, final ApiCallback<List<ProductionDetail>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalClustersClusterIdProductionsGetValidateBeforeCall(clusterId, pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalClustersGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalClustersGetCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/clusters";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalClustersGetValidateBeforeCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalClustersGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalClustersGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalClustersGetCall(pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取分类列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;Cluster&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Cluster> normalClustersGet(Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<Cluster>> resp = normalClustersGetWithHttpInfo(pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取分类列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;Cluster&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Cluster>> normalClustersGetWithHttpInfo(Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalClustersGetValidateBeforeCall(pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<Cluster>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取分类列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalClustersGetAsync(Integer pageNum, Integer pageSize, final ApiCallback<List<Cluster>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalClustersGetValidateBeforeCall(pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Cluster>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalCommentsCommentIdRepliesGet
     * @param commentId 评论ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalCommentsCommentIdRepliesGetCall(Integer commentId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/comments/{commentId}/replies/"
            .replaceAll("\\{" + "commentId" + "\\}", apiClient.escapeString(commentId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalCommentsCommentIdRepliesGetValidateBeforeCall(Integer commentId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'commentId' is set
        if (commentId == null) {
            throw new ApiException("Missing the required parameter 'commentId' when calling normalCommentsCommentIdRepliesGet(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalCommentsCommentIdRepliesGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalCommentsCommentIdRepliesGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalCommentsCommentIdRepliesGetCall(commentId, pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取某个评论的回复
     * 
     * @param commentId 评论ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @return List&lt;ProductionCommentReply&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionCommentReply> normalCommentsCommentIdRepliesGet(Integer commentId, Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<ProductionCommentReply>> resp = normalCommentsCommentIdRepliesGetWithHttpInfo(commentId, pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取某个评论的回复
     * 
     * @param commentId 评论ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @return ApiResponse&lt;List&lt;ProductionCommentReply&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionCommentReply>> normalCommentsCommentIdRepliesGetWithHttpInfo(Integer commentId, Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalCommentsCommentIdRepliesGetValidateBeforeCall(commentId, pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionCommentReply>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取某个评论的回复 (asynchronously)
     * 
     * @param commentId 评论ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalCommentsCommentIdRepliesGetAsync(Integer commentId, Integer pageNum, Integer pageSize, final ApiCallback<List<ProductionCommentReply>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalCommentsCommentIdRepliesGetValidateBeforeCall(commentId, pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionCommentReply>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalGetAllBarragesByVideoIdVideoIdGet
     * @param videoId 视频id (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalGetAllBarragesByVideoIdVideoIdGetCall(String videoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/getAllBarragesByVideoId/{videoId}"
            .replaceAll("\\{" + "videoId" + "\\}", apiClient.escapeString(videoId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalGetAllBarragesByVideoIdVideoIdGetValidateBeforeCall(String videoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'videoId' is set
        if (videoId == null) {
            throw new ApiException("Missing the required parameter 'videoId' when calling normalGetAllBarragesByVideoIdVideoIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalGetAllBarragesByVideoIdVideoIdGetCall(videoId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 通过videoId获取该视频的所有弹幕
     * 
     * @param videoId 视频id (required)
     * @return List&lt;ReturnBarrageInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ReturnBarrageInfo> normalGetAllBarragesByVideoIdVideoIdGet(String videoId) throws ApiException {
        ApiResponse<List<ReturnBarrageInfo>> resp = normalGetAllBarragesByVideoIdVideoIdGetWithHttpInfo(videoId);
        return resp.getData();
    }

    /**
     * 通过videoId获取该视频的所有弹幕
     * 
     * @param videoId 视频id (required)
     * @return ApiResponse&lt;List&lt;ReturnBarrageInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ReturnBarrageInfo>> normalGetAllBarragesByVideoIdVideoIdGetWithHttpInfo(String videoId) throws ApiException {
        com.squareup.okhttp.Call call = normalGetAllBarragesByVideoIdVideoIdGetValidateBeforeCall(videoId, null, null);
        Type localVarReturnType = new TypeToken<List<ReturnBarrageInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 通过videoId获取该视频的所有弹幕 (asynchronously)
     * 
     * @param videoId 视频id (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalGetAllBarragesByVideoIdVideoIdGetAsync(String videoId, final ApiCallback<List<ReturnBarrageInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalGetAllBarragesByVideoIdVideoIdGetValidateBeforeCall(videoId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ReturnBarrageInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalHotsGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalHotsGetCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/hots";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalHotsGetValidateBeforeCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalHotsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalHotsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalHotsGetCall(pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取精选的列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionDetail> normalHotsGet(Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<ProductionDetail>> resp = normalHotsGetWithHttpInfo(pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取精选的列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;ProductionDetail&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionDetail>> normalHotsGetWithHttpInfo(Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalHotsGetValidateBeforeCall(pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取精选的列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalHotsGetAsync(Integer pageNum, Integer pageSize, final ApiCallback<List<ProductionDetail>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalHotsGetValidateBeforeCall(pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalOSSCredentialsGet
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalOSSCredentialsGetCall(String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/OSSCredentials";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalOSSCredentialsGetValidateBeforeCall(String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = normalOSSCredentialsGetCall(requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 上传、下载图片的鉴权
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return OSSCredential
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public OSSCredential normalOSSCredentialsGet(String requestToken) throws ApiException {
        ApiResponse<OSSCredential> resp = normalOSSCredentialsGetWithHttpInfo(requestToken);
        return resp.getData();
    }

    /**
     * 上传、下载图片的鉴权
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;OSSCredential&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<OSSCredential> normalOSSCredentialsGetWithHttpInfo(String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = normalOSSCredentialsGetValidateBeforeCall(requestToken, null, null);
        Type localVarReturnType = new TypeToken<OSSCredential>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 上传、下载图片的鉴权 (asynchronously)
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalOSSCredentialsGetAsync(String requestToken, final ApiCallback<OSSCredential> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalOSSCredentialsGetValidateBeforeCall(requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<OSSCredential>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalPlayNextvideoPost
     * @param productionId 当前视频的Id (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalPlayNextvideoPostCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/playNextvideo";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (productionId != null)
        localVarFormParams.put("productionId", productionId);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalPlayNextvideoPostValidateBeforeCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling normalPlayNextvideoPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalPlayNextvideoPostCall(productionId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 播放下一个视频
     * 
     * @param productionId 当前视频的Id (required)
     * @return ProductionDetail
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProductionDetail normalPlayNextvideoPost(Integer productionId) throws ApiException {
        ApiResponse<ProductionDetail> resp = normalPlayNextvideoPostWithHttpInfo(productionId);
        return resp.getData();
    }

    /**
     * 播放下一个视频
     * 
     * @param productionId 当前视频的Id (required)
     * @return ApiResponse&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProductionDetail> normalPlayNextvideoPostWithHttpInfo(Integer productionId) throws ApiException {
        com.squareup.okhttp.Call call = normalPlayNextvideoPostValidateBeforeCall(productionId, null, null);
        Type localVarReturnType = new TypeToken<ProductionDetail>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 播放下一个视频 (asynchronously)
     * 
     * @param productionId 当前视频的Id (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalPlayNextvideoPostAsync(Integer productionId, final ApiCallback<ProductionDetail> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalPlayNextvideoPostValidateBeforeCall(productionId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProductionDetail>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalProductionViewsPost
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalProductionViewsPostCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/ProductionViews";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (productionId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "productionId", productionId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalProductionViewsPostValidateBeforeCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling normalProductionViewsPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalProductionViewsPostCall(productionId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 上传一次浏览次数
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void normalProductionViewsPost(Integer productionId, String requestToken) throws ApiException {
        normalProductionViewsPostWithHttpInfo(productionId, requestToken);
    }

    /**
     * 上传一次浏览次数
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> normalProductionViewsPostWithHttpInfo(Integer productionId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = normalProductionViewsPostValidateBeforeCall(productionId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 上传一次浏览次数 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalProductionViewsPostAsync(Integer productionId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalProductionViewsPostValidateBeforeCall(productionId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for normalProductionsProductionIdCommentsHotGet
     * @param productionId 作品ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalProductionsProductionIdCommentsHotGetCall(Integer productionId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/productions/{productionId}/comments/hot"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalProductionsProductionIdCommentsHotGetValidateBeforeCall(Integer productionId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling normalProductionsProductionIdCommentsHotGet(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalProductionsProductionIdCommentsHotGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalProductionsProductionIdCommentsHotGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalProductionsProductionIdCommentsHotGetCall(productionId, pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取某个作品的热门评论
     * 
     * @param productionId 作品ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @return List&lt;ProductionComment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionComment> normalProductionsProductionIdCommentsHotGet(Integer productionId, Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<ProductionComment>> resp = normalProductionsProductionIdCommentsHotGetWithHttpInfo(productionId, pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取某个作品的热门评论
     * 
     * @param productionId 作品ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @return ApiResponse&lt;List&lt;ProductionComment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionComment>> normalProductionsProductionIdCommentsHotGetWithHttpInfo(Integer productionId, Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalProductionsProductionIdCommentsHotGetValidateBeforeCall(productionId, pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionComment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取某个作品的热门评论 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalProductionsProductionIdCommentsHotGetAsync(Integer productionId, Integer pageNum, Integer pageSize, final ApiCallback<List<ProductionComment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalProductionsProductionIdCommentsHotGetValidateBeforeCall(productionId, pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionComment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalProductionsProductionIdCommentsNewGet
     * @param productionId 作品ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalProductionsProductionIdCommentsNewGetCall(Integer productionId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/productions/{productionId}/comments/new"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalProductionsProductionIdCommentsNewGetValidateBeforeCall(Integer productionId, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling normalProductionsProductionIdCommentsNewGet(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalProductionsProductionIdCommentsNewGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalProductionsProductionIdCommentsNewGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalProductionsProductionIdCommentsNewGetCall(productionId, pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取某个作品的最新评论
     * 
     * @param productionId 作品ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @return List&lt;ProductionComment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionComment> normalProductionsProductionIdCommentsNewGet(Integer productionId, Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<ProductionComment>> resp = normalProductionsProductionIdCommentsNewGetWithHttpInfo(productionId, pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取某个作品的最新评论
     * 
     * @param productionId 作品ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @return ApiResponse&lt;List&lt;ProductionComment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionComment>> normalProductionsProductionIdCommentsNewGetWithHttpInfo(Integer productionId, Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalProductionsProductionIdCommentsNewGetValidateBeforeCall(productionId, pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionComment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取某个作品的最新评论 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalProductionsProductionIdCommentsNewGetAsync(Integer productionId, Integer pageNum, Integer pageSize, final ApiCallback<List<ProductionComment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalProductionsProductionIdCommentsNewGetValidateBeforeCall(productionId, pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionComment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalProductionsProductionIdGet
     * @param productionId 作品ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalProductionsProductionIdGetCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/productions/{productionId}"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalProductionsProductionIdGetValidateBeforeCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling normalProductionsProductionIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalProductionsProductionIdGetCall(productionId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取某个作品的作品详情
     * 
     * @param productionId 作品ID (required)
     * @return ProductionDetail
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProductionDetail normalProductionsProductionIdGet(Integer productionId) throws ApiException {
        ApiResponse<ProductionDetail> resp = normalProductionsProductionIdGetWithHttpInfo(productionId);
        return resp.getData();
    }

    /**
     * 获取某个作品的作品详情
     * 
     * @param productionId 作品ID (required)
     * @return ApiResponse&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProductionDetail> normalProductionsProductionIdGetWithHttpInfo(Integer productionId) throws ApiException {
        com.squareup.okhttp.Call call = normalProductionsProductionIdGetValidateBeforeCall(productionId, null, null);
        Type localVarReturnType = new TypeToken<ProductionDetail>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取某个作品的作品详情 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalProductionsProductionIdGetAsync(Integer productionId, final ApiCallback<ProductionDetail> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalProductionsProductionIdGetValidateBeforeCall(productionId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProductionDetail>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalProductionsProductionIdSharedGet
     * @param productionId 作品ID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalProductionsProductionIdSharedGetCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/productions/{productionId}/shared"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalProductionsProductionIdSharedGetValidateBeforeCall(Integer productionId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling normalProductionsProductionIdSharedGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalProductionsProductionIdSharedGetCall(productionId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 分享作品结束
     * 
     * @param productionId 作品ID (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void normalProductionsProductionIdSharedGet(Integer productionId) throws ApiException {
        normalProductionsProductionIdSharedGetWithHttpInfo(productionId);
    }

    /**
     * 分享作品结束
     * 
     * @param productionId 作品ID (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> normalProductionsProductionIdSharedGetWithHttpInfo(Integer productionId) throws ApiException {
        com.squareup.okhttp.Call call = normalProductionsProductionIdSharedGetValidateBeforeCall(productionId, null, null);
        return apiClient.execute(call);
    }

    /**
     * 分享作品结束 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalProductionsProductionIdSharedGetAsync(Integer productionId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalProductionsProductionIdSharedGetValidateBeforeCall(productionId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for normalPutUrlFolderGet
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalPutUrlFolderGetCall(String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/PutUrlFolder";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalPutUrlFolderGetValidateBeforeCall(String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = normalPutUrlFolderGetCall(requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 上传图片的文件夹
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return OssUrl
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public OssUrl normalPutUrlFolderGet(String requestToken) throws ApiException {
        ApiResponse<OssUrl> resp = normalPutUrlFolderGetWithHttpInfo(requestToken);
        return resp.getData();
    }

    /**
     * 上传图片的文件夹
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;OssUrl&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<OssUrl> normalPutUrlFolderGetWithHttpInfo(String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = normalPutUrlFolderGetValidateBeforeCall(requestToken, null, null);
        Type localVarReturnType = new TypeToken<OssUrl>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 上传图片的文件夹 (asynchronously)
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalPutUrlFolderGetAsync(String requestToken, final ApiCallback<OssUrl> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalPutUrlFolderGetValidateBeforeCall(requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<OssUrl>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalSearchAuthorsGet
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalSearchAuthorsGetCall(String keyWord, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/search/authors";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (keyWord != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "keyWord", keyWord));
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalSearchAuthorsGetValidateBeforeCall(String keyWord, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'keyWord' is set
        if (keyWord == null) {
            throw new ApiException("Missing the required parameter 'keyWord' when calling normalSearchAuthorsGet(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalSearchAuthorsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalSearchAuthorsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalSearchAuthorsGetCall(keyWord, pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 搜索授权号（根据name,description）
     * 
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;AuthorInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<AuthorInfo> normalSearchAuthorsGet(String keyWord, Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<AuthorInfo>> resp = normalSearchAuthorsGetWithHttpInfo(keyWord, pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 搜索授权号（根据name,description）
     * 
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;AuthorInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<AuthorInfo>> normalSearchAuthorsGetWithHttpInfo(String keyWord, Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalSearchAuthorsGetValidateBeforeCall(keyWord, pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 搜索授权号（根据name,description） (asynchronously)
     * 
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalSearchAuthorsGetAsync(String keyWord, Integer pageNum, Integer pageSize, final ApiCallback<List<AuthorInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalSearchAuthorsGetValidateBeforeCall(keyWord, pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<AuthorInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalSearchProductionsGet
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalSearchProductionsGetCall(String keyWord, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/search/productions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (keyWord != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "keyWord", keyWord));
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalSearchProductionsGetValidateBeforeCall(String keyWord, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'keyWord' is set
        if (keyWord == null) {
            throw new ApiException("Missing the required parameter 'keyWord' when calling normalSearchProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalSearchProductionsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalSearchProductionsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalSearchProductionsGetCall(keyWord, pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 搜索作品（根据titile，description）
     * 
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;ProductionDetail&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ProductionDetail> normalSearchProductionsGet(String keyWord, Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<ProductionDetail>> resp = normalSearchProductionsGetWithHttpInfo(keyWord, pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 搜索作品（根据titile，description）
     * 
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;ProductionDetail&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ProductionDetail>> normalSearchProductionsGetWithHttpInfo(String keyWord, Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalSearchProductionsGetValidateBeforeCall(keyWord, pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 搜索作品（根据titile，description） (asynchronously)
     * 
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalSearchProductionsGetAsync(String keyWord, Integer pageNum, Integer pageSize, final ApiCallback<List<ProductionDetail>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalSearchProductionsGetValidateBeforeCall(keyWord, pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ProductionDetail>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalSearchTagGet
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalSearchTagGetCall(String keyWord, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/search/tag";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (keyWord != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "keyWord", keyWord));
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalSearchTagGetValidateBeforeCall(String keyWord, Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'keyWord' is set
        if (keyWord == null) {
            throw new ApiException("Missing the required parameter 'keyWord' when calling normalSearchTagGet(Async)");
        }
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalSearchTagGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalSearchTagGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalSearchTagGetCall(keyWord, pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 搜索tag（根据name,description）
     * 
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return List&lt;Tag&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Tag> normalSearchTagGet(String keyWord, Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<Tag>> resp = normalSearchTagGetWithHttpInfo(keyWord, pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 搜索tag（根据name,description）
     * 
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @return ApiResponse&lt;List&lt;Tag&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Tag>> normalSearchTagGetWithHttpInfo(String keyWord, Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalSearchTagGetValidateBeforeCall(keyWord, pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<Tag>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 搜索tag（根据name,description） (asynchronously)
     * 
     * @param keyWord 搜索的关键字 (required)
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalSearchTagGetAsync(String keyWord, Integer pageNum, Integer pageSize, final ApiCallback<List<Tag>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalSearchTagGetValidateBeforeCall(keyWord, pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Tag>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalStartAppOpenTimesPost
     * @param machineType 设备型号 (optional)
     * @param openTimes 打开次数 (optional)
     * @param durationTime 在线时长 (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalStartAppOpenTimesPostCall(String machineType, Integer openTimes, String durationTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/StartAppOpenTimes";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (machineType != null)
        localVarFormParams.put("machineType", machineType);
        if (openTimes != null)
        localVarFormParams.put("openTimes", openTimes);
        if (durationTime != null)
        localVarFormParams.put("durationTime", durationTime);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalStartAppOpenTimesPostValidateBeforeCall(String machineType, Integer openTimes, String durationTime, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = normalStartAppOpenTimesPostCall(machineType, openTimes, durationTime, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 查看用户启动APP的次数和在线时间长短
     * 
     * @param machineType 设备型号 (optional)
     * @param openTimes 打开次数 (optional)
     * @param durationTime 在线时长 (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void normalStartAppOpenTimesPost(String machineType, Integer openTimes, String durationTime) throws ApiException {
        normalStartAppOpenTimesPostWithHttpInfo(machineType, openTimes, durationTime);
    }

    /**
     * 查看用户启动APP的次数和在线时间长短
     * 
     * @param machineType 设备型号 (optional)
     * @param openTimes 打开次数 (optional)
     * @param durationTime 在线时长 (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> normalStartAppOpenTimesPostWithHttpInfo(String machineType, Integer openTimes, String durationTime) throws ApiException {
        com.squareup.okhttp.Call call = normalStartAppOpenTimesPostValidateBeforeCall(machineType, openTimes, durationTime, null, null);
        return apiClient.execute(call);
    }

    /**
     * 查看用户启动APP的次数和在线时间长短 (asynchronously)
     * 
     * @param machineType 设备型号 (optional)
     * @param openTimes 打开次数 (optional)
     * @param durationTime 在线时长 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalStartAppOpenTimesPostAsync(String machineType, Integer openTimes, String durationTime, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalStartAppOpenTimesPostValidateBeforeCall(machineType, openTimes, durationTime, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for normalTagsGet
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalTagsGetCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/tags";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalTagsGetValidateBeforeCall(Integer pageNum, Integer pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling normalTagsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling normalTagsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalTagsGetCall(pageNum, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取关键词列表
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @return List&lt;Tag&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Tag> normalTagsGet(Integer pageNum, Integer pageSize) throws ApiException {
        ApiResponse<List<Tag>> resp = normalTagsGetWithHttpInfo(pageNum, pageSize);
        return resp.getData();
    }

    /**
     * 获取关键词列表
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @return ApiResponse&lt;List&lt;Tag&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Tag>> normalTagsGetWithHttpInfo(Integer pageNum, Integer pageSize) throws ApiException {
        com.squareup.okhttp.Call call = normalTagsGetValidateBeforeCall(pageNum, pageSize, null, null);
        Type localVarReturnType = new TypeToken<List<Tag>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取关键词列表 (asynchronously)
     * 
     * @param pageNum  (required)
     * @param pageSize  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalTagsGetAsync(Integer pageNum, Integer pageSize, final ApiCallback<List<Tag>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalTagsGetValidateBeforeCall(pageNum, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Tag>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalTagsTagIdGet
     * @param tagId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalTagsTagIdGetCall(Integer tagId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/tags/{tagId}"
            .replaceAll("\\{" + "tagId" + "\\}", apiClient.escapeString(tagId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalTagsTagIdGetValidateBeforeCall(Integer tagId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tagId' is set
        if (tagId == null) {
            throw new ApiException("Missing the required parameter 'tagId' when calling normalTagsTagIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalTagsTagIdGetCall(tagId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取某个tag的信息
     * 
     * @param tagId  (required)
     * @return Tag
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Tag normalTagsTagIdGet(Integer tagId) throws ApiException {
        ApiResponse<Tag> resp = normalTagsTagIdGetWithHttpInfo(tagId);
        return resp.getData();
    }

    /**
     * 获取某个tag的信息
     * 
     * @param tagId  (required)
     * @return ApiResponse&lt;Tag&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Tag> normalTagsTagIdGetWithHttpInfo(Integer tagId) throws ApiException {
        com.squareup.okhttp.Call call = normalTagsTagIdGetValidateBeforeCall(tagId, null, null);
        Type localVarReturnType = new TypeToken<Tag>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取某个tag的信息 (asynchronously)
     * 
     * @param tagId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalTagsTagIdGetAsync(Integer tagId, final ApiCallback<Tag> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalTagsTagIdGetValidateBeforeCall(tagId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Tag>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for normalVideoPlayAuthVideoIdGet
     * @param videoId videoID (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call normalVideoPlayAuthVideoIdGetCall(String videoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/normal/videoPlayAuth/{videoId}"
            .replaceAll("\\{" + "videoId" + "\\}", apiClient.escapeString(videoId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call normalVideoPlayAuthVideoIdGetValidateBeforeCall(String videoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'videoId' is set
        if (videoId == null) {
            throw new ApiException("Missing the required parameter 'videoId' when calling normalVideoPlayAuthVideoIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = normalVideoPlayAuthVideoIdGetCall(videoId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取视频播放鉴权
     * 
     * @param videoId videoID (required)
     * @return VideoPlayAuth
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public VideoPlayAuth normalVideoPlayAuthVideoIdGet(String videoId) throws ApiException {
        ApiResponse<VideoPlayAuth> resp = normalVideoPlayAuthVideoIdGetWithHttpInfo(videoId);
        return resp.getData();
    }

    /**
     * 获取视频播放鉴权
     * 
     * @param videoId videoID (required)
     * @return ApiResponse&lt;VideoPlayAuth&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<VideoPlayAuth> normalVideoPlayAuthVideoIdGetWithHttpInfo(String videoId) throws ApiException {
        com.squareup.okhttp.Call call = normalVideoPlayAuthVideoIdGetValidateBeforeCall(videoId, null, null);
        Type localVarReturnType = new TypeToken<VideoPlayAuth>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取视频播放鉴权 (asynchronously)
     * 
     * @param videoId videoID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call normalVideoPlayAuthVideoIdGetAsync(String videoId, final ApiCallback<VideoPlayAuth> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = normalVideoPlayAuthVideoIdGetValidateBeforeCall(videoId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<VideoPlayAuth>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
