/*
 * 柏九后端接口
 * ## 错误规则  ###    401 - 未登录，如果出现这个错误，请调用 登录/自动登录 接口刷新session或者requresttoken ###    403 - 权限不足， 一般不会出现这个错误 ###    417 - 碰到这个错误请将response的body解析为ErrorInfo一般情况是直接将ErrorInfo中的errorMessage 直接展现给用户 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package net.bojiu.android.io.swagger.api;

import net.bojiu.android.io.swagger.ApiCallback;
import net.bojiu.android.io.swagger.ApiClient;
import net.bojiu.android.io.swagger.ApiException;
import net.bojiu.android.io.swagger.ApiResponse;
import net.bojiu.android.io.swagger.Configuration;
import net.bojiu.android.io.swagger.Pair;
import net.bojiu.android.io.swagger.ProgressRequestBody;
import net.bojiu.android.io.swagger.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import net.bojiu.android.io.swagger.model.Barrage;
import net.bojiu.android.io.swagger.model.CommentLikeMessage;
import net.bojiu.android.io.swagger.model.CommentReplyMessage;
import net.bojiu.android.io.swagger.model.FavoriteProduction;
import net.bojiu.android.io.swagger.model.FollowedAuthorInfo;
import net.bojiu.android.io.swagger.model.HistoryProduction;
import net.bojiu.android.io.swagger.model.IdWrapper;
import net.bojiu.android.io.swagger.model.ReturnBarrageInfo;
import net.bojiu.android.io.swagger.model.UserInfo;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class UserApi {
    private ApiClient apiClient;

    public UserApi() {
        this(Configuration.getDefaultApiClient());
    }

    public UserApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for userBarragePost
     * @param barrageInfo 创建弹幕信息 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userBarragePostCall(Barrage barrageInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = barrageInfo;
        
        // create path and map variables
        String localVarPath = "/user/barrage";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userBarragePostValidateBeforeCall(Barrage barrageInfo, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'barrageInfo' is set
        if (barrageInfo == null) {
            throw new ApiException("Missing the required parameter 'barrageInfo' when calling userBarragePost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userBarragePostCall(barrageInfo, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 创建弹幕
     * 
     * @param barrageInfo 创建弹幕信息 (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String userBarragePost(Barrage barrageInfo) throws ApiException {
        ApiResponse<String> resp = userBarragePostWithHttpInfo(barrageInfo);
        return resp.getData();
    }

    /**
     * 创建弹幕
     * 
     * @param barrageInfo 创建弹幕信息 (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> userBarragePostWithHttpInfo(Barrage barrageInfo) throws ApiException {
        com.squareup.okhttp.Call call = userBarragePostValidateBeforeCall(barrageInfo, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 创建弹幕 (asynchronously)
     * 
     * @param barrageInfo 创建弹幕信息 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userBarragePostAsync(Barrage barrageInfo, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userBarragePostValidateBeforeCall(barrageInfo, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userCommentLikeDelete
     * @param commentId 评论ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userCommentLikeDeleteCall(Integer commentId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/comment/like";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (commentId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "commentId", commentId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userCommentLikeDeleteValidateBeforeCall(Integer commentId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'commentId' is set
        if (commentId == null) {
            throw new ApiException("Missing the required parameter 'commentId' when calling userCommentLikeDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userCommentLikeDeleteCall(commentId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户取消点赞评论
     * 
     * @param commentId 评论ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userCommentLikeDelete(Integer commentId, String requestToken) throws ApiException {
        userCommentLikeDeleteWithHttpInfo(commentId, requestToken);
    }

    /**
     * 用户取消点赞评论
     * 
     * @param commentId 评论ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userCommentLikeDeleteWithHttpInfo(Integer commentId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userCommentLikeDeleteValidateBeforeCall(commentId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 用户取消点赞评论 (asynchronously)
     * 
     * @param commentId 评论ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userCommentLikeDeleteAsync(Integer commentId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userCommentLikeDeleteValidateBeforeCall(commentId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userCommentLikeGet
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userCommentLikeGetCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/comment/like";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (productionId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "productionId", productionId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userCommentLikeGetValidateBeforeCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling userCommentLikeGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userCommentLikeGetCall(productionId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取用户该作品下的点赞评论ID列表
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return List&lt;IdWrapper&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<IdWrapper> userCommentLikeGet(Integer productionId, String requestToken) throws ApiException {
        ApiResponse<List<IdWrapper>> resp = userCommentLikeGetWithHttpInfo(productionId, requestToken);
        return resp.getData();
    }

    /**
     * 获取用户该作品下的点赞评论ID列表
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;List&lt;IdWrapper&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<IdWrapper>> userCommentLikeGetWithHttpInfo(Integer productionId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userCommentLikeGetValidateBeforeCall(productionId, requestToken, null, null);
        Type localVarReturnType = new TypeToken<List<IdWrapper>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取用户该作品下的点赞评论ID列表 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userCommentLikeGetAsync(Integer productionId, String requestToken, final ApiCallback<List<IdWrapper>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userCommentLikeGetValidateBeforeCall(productionId, requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<IdWrapper>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userCommentLikePost
     * @param commentId 评论ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userCommentLikePostCall(Integer commentId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/comment/like";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (commentId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "commentId", commentId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userCommentLikePostValidateBeforeCall(Integer commentId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'commentId' is set
        if (commentId == null) {
            throw new ApiException("Missing the required parameter 'commentId' when calling userCommentLikePost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userCommentLikePostCall(commentId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户点赞评论
     * 
     * @param commentId 评论ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userCommentLikePost(Integer commentId, String requestToken) throws ApiException {
        userCommentLikePostWithHttpInfo(commentId, requestToken);
    }

    /**
     * 用户点赞评论
     * 
     * @param commentId 评论ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userCommentLikePostWithHttpInfo(Integer commentId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userCommentLikePostValidateBeforeCall(commentId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 用户点赞评论 (asynchronously)
     * 
     * @param commentId 评论ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userCommentLikePostAsync(Integer commentId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userCommentLikePostValidateBeforeCall(commentId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userCommentsCommentIdLikeGet
     * @param commentId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userCommentsCommentIdLikeGetCall(Integer commentId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/comments/{commentId}/like"
            .replaceAll("\\{" + "commentId" + "\\}", apiClient.escapeString(commentId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userCommentsCommentIdLikeGetValidateBeforeCall(Integer commentId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'commentId' is set
        if (commentId == null) {
            throw new ApiException("Missing the required parameter 'commentId' when calling userCommentsCommentIdLikeGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userCommentsCommentIdLikeGetCall(commentId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取用户某个评论是否有点赞的接口
     * 
     * @param commentId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userCommentsCommentIdLikeGet(Integer commentId, String requestToken) throws ApiException {
        userCommentsCommentIdLikeGetWithHttpInfo(commentId, requestToken);
    }

    /**
     * 获取用户某个评论是否有点赞的接口
     * 
     * @param commentId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userCommentsCommentIdLikeGetWithHttpInfo(Integer commentId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userCommentsCommentIdLikeGetValidateBeforeCall(commentId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 获取用户某个评论是否有点赞的接口 (asynchronously)
     * 
     * @param commentId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userCommentsCommentIdLikeGetAsync(Integer commentId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userCommentsCommentIdLikeGetValidateBeforeCall(commentId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userCommentsPost
     * @param productionId 作品ID (required)
     * @param comment 评论内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userCommentsPostCall(Integer productionId, String comment, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/comments";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (productionId != null)
        localVarFormParams.put("productionId", productionId);
        if (comment != null)
        localVarFormParams.put("comment", comment);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userCommentsPostValidateBeforeCall(Integer productionId, String comment, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling userCommentsPost(Async)");
        }
        
        // verify the required parameter 'comment' is set
        if (comment == null) {
            throw new ApiException("Missing the required parameter 'comment' when calling userCommentsPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userCommentsPostCall(productionId, comment, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户发表评论
     * 
     * @param productionId 作品ID (required)
     * @param comment 评论内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userCommentsPost(Integer productionId, String comment, String requestToken) throws ApiException {
        userCommentsPostWithHttpInfo(productionId, comment, requestToken);
    }

    /**
     * 用户发表评论
     * 
     * @param productionId 作品ID (required)
     * @param comment 评论内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userCommentsPostWithHttpInfo(Integer productionId, String comment, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userCommentsPostValidateBeforeCall(productionId, comment, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 用户发表评论 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param comment 评论内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userCommentsPostAsync(Integer productionId, String comment, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userCommentsPostValidateBeforeCall(productionId, comment, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userFavoriteProductionIdGet
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userFavoriteProductionIdGetCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/favorite/{productionId}"
            .replaceAll("\\{" + "productionId" + "\\}", apiClient.escapeString(productionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userFavoriteProductionIdGetValidateBeforeCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling userFavoriteProductionIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userFavoriteProductionIdGetCall(productionId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户获取自己收藏的某个作品
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userFavoriteProductionIdGet(Integer productionId, String requestToken) throws ApiException {
        userFavoriteProductionIdGetWithHttpInfo(productionId, requestToken);
    }

    /**
     * 用户获取自己收藏的某个作品
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userFavoriteProductionIdGetWithHttpInfo(Integer productionId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userFavoriteProductionIdGetValidateBeforeCall(productionId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 用户获取自己收藏的某个作品 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userFavoriteProductionIdGetAsync(Integer productionId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userFavoriteProductionIdGetValidateBeforeCall(productionId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userFavoritesDelete
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userFavoritesDeleteCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/favorites";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (productionId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "productionId", productionId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userFavoritesDeleteValidateBeforeCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling userFavoritesDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userFavoritesDeleteCall(productionId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户删除自己收藏
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userFavoritesDelete(Integer productionId, String requestToken) throws ApiException {
        userFavoritesDeleteWithHttpInfo(productionId, requestToken);
    }

    /**
     * 用户删除自己收藏
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userFavoritesDeleteWithHttpInfo(Integer productionId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userFavoritesDeleteValidateBeforeCall(productionId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 用户删除自己收藏 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userFavoritesDeleteAsync(Integer productionId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userFavoritesDeleteValidateBeforeCall(productionId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userFavoritesGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userFavoritesGetCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/favorites";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userFavoritesGetValidateBeforeCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling userFavoritesGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling userFavoritesGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userFavoritesGetCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 会员用户获取自己收藏的作品列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return List&lt;FavoriteProduction&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<FavoriteProduction> userFavoritesGet(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        ApiResponse<List<FavoriteProduction>> resp = userFavoritesGetWithHttpInfo(pageNum, pageSize, requestToken);
        return resp.getData();
    }

    /**
     * 会员用户获取自己收藏的作品列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;List&lt;FavoriteProduction&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<FavoriteProduction>> userFavoritesGetWithHttpInfo(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userFavoritesGetValidateBeforeCall(pageNum, pageSize, requestToken, null, null);
        Type localVarReturnType = new TypeToken<List<FavoriteProduction>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 会员用户获取自己收藏的作品列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userFavoritesGetAsync(Integer pageNum, Integer pageSize, String requestToken, final ApiCallback<List<FavoriteProduction>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userFavoritesGetValidateBeforeCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<FavoriteProduction>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userFavoritesPost
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userFavoritesPostCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/favorites";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (productionId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "productionId", productionId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userFavoritesPostValidateBeforeCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling userFavoritesPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userFavoritesPostCall(productionId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户添加收藏
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userFavoritesPost(Integer productionId, String requestToken) throws ApiException {
        userFavoritesPostWithHttpInfo(productionId, requestToken);
    }

    /**
     * 用户添加收藏
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userFavoritesPostWithHttpInfo(Integer productionId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userFavoritesPostValidateBeforeCall(productionId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 用户添加收藏 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userFavoritesPostAsync(Integer productionId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userFavoritesPostValidateBeforeCall(productionId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userFollowAuthorIdGet
     * @param authorId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userFollowAuthorIdGetCall(Integer authorId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/follow/{authorId}"
            .replaceAll("\\{" + "authorId" + "\\}", apiClient.escapeString(authorId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userFollowAuthorIdGetValidateBeforeCall(Integer authorId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling userFollowAuthorIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userFollowAuthorIdGetCall(authorId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户获取自己关注的某个作者
     * 
     * @param authorId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userFollowAuthorIdGet(Integer authorId, String requestToken) throws ApiException {
        userFollowAuthorIdGetWithHttpInfo(authorId, requestToken);
    }

    /**
     * 用户获取自己关注的某个作者
     * 
     * @param authorId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userFollowAuthorIdGetWithHttpInfo(Integer authorId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userFollowAuthorIdGetValidateBeforeCall(authorId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 用户获取自己关注的某个作者 (asynchronously)
     * 
     * @param authorId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userFollowAuthorIdGetAsync(Integer authorId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userFollowAuthorIdGetValidateBeforeCall(authorId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userFollowsDelete
     * @param authorId 作者ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userFollowsDeleteCall(Integer authorId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/follows";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (authorId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "authorId", authorId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userFollowsDeleteValidateBeforeCall(Integer authorId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling userFollowsDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userFollowsDeleteCall(authorId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 取消关注作者
     * 
     * @param authorId 作者ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userFollowsDelete(Integer authorId, String requestToken) throws ApiException {
        userFollowsDeleteWithHttpInfo(authorId, requestToken);
    }

    /**
     * 取消关注作者
     * 
     * @param authorId 作者ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userFollowsDeleteWithHttpInfo(Integer authorId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userFollowsDeleteValidateBeforeCall(authorId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 取消关注作者 (asynchronously)
     * 
     * @param authorId 作者ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userFollowsDeleteAsync(Integer authorId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userFollowsDeleteValidateBeforeCall(authorId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userFollowsGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userFollowsGetCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/follows";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userFollowsGetValidateBeforeCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling userFollowsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling userFollowsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userFollowsGetCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 会员用户获取自己关注的作者列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return List&lt;FollowedAuthorInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<FollowedAuthorInfo> userFollowsGet(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        ApiResponse<List<FollowedAuthorInfo>> resp = userFollowsGetWithHttpInfo(pageNum, pageSize, requestToken);
        return resp.getData();
    }

    /**
     * 会员用户获取自己关注的作者列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;List&lt;FollowedAuthorInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<FollowedAuthorInfo>> userFollowsGetWithHttpInfo(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userFollowsGetValidateBeforeCall(pageNum, pageSize, requestToken, null, null);
        Type localVarReturnType = new TypeToken<List<FollowedAuthorInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 会员用户获取自己关注的作者列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userFollowsGetAsync(Integer pageNum, Integer pageSize, String requestToken, final ApiCallback<List<FollowedAuthorInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userFollowsGetValidateBeforeCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<FollowedAuthorInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userFollowsPost
     * @param authorId 作者ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userFollowsPostCall(Integer authorId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/follows";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (authorId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "authorId", authorId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userFollowsPostValidateBeforeCall(Integer authorId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'authorId' is set
        if (authorId == null) {
            throw new ApiException("Missing the required parameter 'authorId' when calling userFollowsPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userFollowsPostCall(authorId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 添加关注作者
     * 
     * @param authorId 作者ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userFollowsPost(Integer authorId, String requestToken) throws ApiException {
        userFollowsPostWithHttpInfo(authorId, requestToken);
    }

    /**
     * 添加关注作者
     * 
     * @param authorId 作者ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userFollowsPostWithHttpInfo(Integer authorId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userFollowsPostValidateBeforeCall(authorId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 添加关注作者 (asynchronously)
     * 
     * @param authorId 作者ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userFollowsPostAsync(Integer authorId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userFollowsPostValidateBeforeCall(authorId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userGetAllBarragesByVideoIdVideoIdGet
     * @param videoId 视频id (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userGetAllBarragesByVideoIdVideoIdGetCall(String videoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/getAllBarragesByVideoId/{videoId}"
            .replaceAll("\\{" + "videoId" + "\\}", apiClient.escapeString(videoId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userGetAllBarragesByVideoIdVideoIdGetValidateBeforeCall(String videoId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'videoId' is set
        if (videoId == null) {
            throw new ApiException("Missing the required parameter 'videoId' when calling userGetAllBarragesByVideoIdVideoIdGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userGetAllBarragesByVideoIdVideoIdGetCall(videoId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 通过videoId获取该视频的所有弹幕
     * 
     * @param videoId 视频id (required)
     * @return List&lt;ReturnBarrageInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ReturnBarrageInfo> userGetAllBarragesByVideoIdVideoIdGet(String videoId) throws ApiException {
        ApiResponse<List<ReturnBarrageInfo>> resp = userGetAllBarragesByVideoIdVideoIdGetWithHttpInfo(videoId);
        return resp.getData();
    }

    /**
     * 通过videoId获取该视频的所有弹幕
     * 
     * @param videoId 视频id (required)
     * @return ApiResponse&lt;List&lt;ReturnBarrageInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ReturnBarrageInfo>> userGetAllBarragesByVideoIdVideoIdGetWithHttpInfo(String videoId) throws ApiException {
        com.squareup.okhttp.Call call = userGetAllBarragesByVideoIdVideoIdGetValidateBeforeCall(videoId, null, null);
        Type localVarReturnType = new TypeToken<List<ReturnBarrageInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 通过videoId获取该视频的所有弹幕 (asynchronously)
     * 
     * @param videoId 视频id (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userGetAllBarragesByVideoIdVideoIdGetAsync(String videoId, final ApiCallback<List<ReturnBarrageInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userGetAllBarragesByVideoIdVideoIdGetValidateBeforeCall(videoId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ReturnBarrageInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userHistoriesDelete
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userHistoriesDeleteCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/histories";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (productionId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "productionId", productionId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userHistoriesDeleteValidateBeforeCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling userHistoriesDelete(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userHistoriesDeleteCall(productionId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 删除浏览历史
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userHistoriesDelete(Integer productionId, String requestToken) throws ApiException {
        userHistoriesDeleteWithHttpInfo(productionId, requestToken);
    }

    /**
     * 删除浏览历史
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userHistoriesDeleteWithHttpInfo(Integer productionId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userHistoriesDeleteValidateBeforeCall(productionId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 删除浏览历史 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userHistoriesDeleteAsync(Integer productionId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userHistoriesDeleteValidateBeforeCall(productionId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userHistoriesGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userHistoriesGetCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/histories";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userHistoriesGetValidateBeforeCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling userHistoriesGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling userHistoriesGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userHistoriesGetCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户获取自己的浏览历史
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return List&lt;HistoryProduction&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<HistoryProduction> userHistoriesGet(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        ApiResponse<List<HistoryProduction>> resp = userHistoriesGetWithHttpInfo(pageNum, pageSize, requestToken);
        return resp.getData();
    }

    /**
     * 用户获取自己的浏览历史
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;List&lt;HistoryProduction&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<HistoryProduction>> userHistoriesGetWithHttpInfo(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userHistoriesGetValidateBeforeCall(pageNum, pageSize, requestToken, null, null);
        Type localVarReturnType = new TypeToken<List<HistoryProduction>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 用户获取自己的浏览历史 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userHistoriesGetAsync(Integer pageNum, Integer pageSize, String requestToken, final ApiCallback<List<HistoryProduction>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userHistoriesGetValidateBeforeCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<HistoryProduction>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userHistoriesPost
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userHistoriesPostCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/histories";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (productionId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "productionId", productionId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userHistoriesPostValidateBeforeCall(Integer productionId, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'productionId' is set
        if (productionId == null) {
            throw new ApiException("Missing the required parameter 'productionId' when calling userHistoriesPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userHistoriesPostCall(productionId, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户上传浏览历史
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userHistoriesPost(Integer productionId, String requestToken) throws ApiException {
        userHistoriesPostWithHttpInfo(productionId, requestToken);
    }

    /**
     * 用户上传浏览历史
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userHistoriesPostWithHttpInfo(Integer productionId, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userHistoriesPostValidateBeforeCall(productionId, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 用户上传浏览历史 (asynchronously)
     * 
     * @param productionId 作品ID (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userHistoriesPostAsync(Integer productionId, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userHistoriesPostValidateBeforeCall(productionId, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userMessageCommentsGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userMessageCommentsGetCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/message/comments";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userMessageCommentsGetValidateBeforeCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling userMessageCommentsGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling userMessageCommentsGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userMessageCommentsGetCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取我评论的消息列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return List&lt;CommentReplyMessage&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<CommentReplyMessage> userMessageCommentsGet(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        ApiResponse<List<CommentReplyMessage>> resp = userMessageCommentsGetWithHttpInfo(pageNum, pageSize, requestToken);
        return resp.getData();
    }

    /**
     * 获取我评论的消息列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;List&lt;CommentReplyMessage&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<CommentReplyMessage>> userMessageCommentsGetWithHttpInfo(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userMessageCommentsGetValidateBeforeCall(pageNum, pageSize, requestToken, null, null);
        Type localVarReturnType = new TypeToken<List<CommentReplyMessage>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取我评论的消息列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userMessageCommentsGetAsync(Integer pageNum, Integer pageSize, String requestToken, final ApiCallback<List<CommentReplyMessage>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userMessageCommentsGetValidateBeforeCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<CommentReplyMessage>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userMessageLikesGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userMessageLikesGetCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/message/likes";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userMessageLikesGetValidateBeforeCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling userMessageLikesGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling userMessageLikesGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userMessageLikesGetCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取点赞的消息列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return List&lt;CommentLikeMessage&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<CommentLikeMessage> userMessageLikesGet(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        ApiResponse<List<CommentLikeMessage>> resp = userMessageLikesGetWithHttpInfo(pageNum, pageSize, requestToken);
        return resp.getData();
    }

    /**
     * 获取点赞的消息列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;List&lt;CommentLikeMessage&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<CommentLikeMessage>> userMessageLikesGetWithHttpInfo(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userMessageLikesGetValidateBeforeCall(pageNum, pageSize, requestToken, null, null);
        Type localVarReturnType = new TypeToken<List<CommentLikeMessage>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取点赞的消息列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userMessageLikesGetAsync(Integer pageNum, Integer pageSize, String requestToken, final ApiCallback<List<CommentLikeMessage>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userMessageLikesGetValidateBeforeCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<CommentLikeMessage>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userMessageRepliesGet
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userMessageRepliesGetCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/message/replies";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));
        if (pageNum != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageNum", pageNum));
        if (pageSize != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageSize", pageSize));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userMessageRepliesGetValidateBeforeCall(Integer pageNum, Integer pageSize, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'pageNum' is set
        if (pageNum == null) {
            throw new ApiException("Missing the required parameter 'pageNum' when calling userMessageRepliesGet(Async)");
        }
        
        // verify the required parameter 'pageSize' is set
        if (pageSize == null) {
            throw new ApiException("Missing the required parameter 'pageSize' when calling userMessageRepliesGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userMessageRepliesGetCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 获取回复的消息列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return List&lt;CommentReplyMessage&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<CommentReplyMessage> userMessageRepliesGet(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        ApiResponse<List<CommentReplyMessage>> resp = userMessageRepliesGetWithHttpInfo(pageNum, pageSize, requestToken);
        return resp.getData();
    }

    /**
     * 获取回复的消息列表
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;List&lt;CommentReplyMessage&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<CommentReplyMessage>> userMessageRepliesGetWithHttpInfo(Integer pageNum, Integer pageSize, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userMessageRepliesGetValidateBeforeCall(pageNum, pageSize, requestToken, null, null);
        Type localVarReturnType = new TypeToken<List<CommentReplyMessage>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 获取回复的消息列表 (asynchronously)
     * 
     * @param pageNum 需要第几页 (required)
     * @param pageSize 每页的大小 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userMessageRepliesGetAsync(Integer pageNum, Integer pageSize, String requestToken, final ApiCallback<List<CommentReplyMessage>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userMessageRepliesGetValidateBeforeCall(pageNum, pageSize, requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<CommentReplyMessage>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userRepliesPost
     * @param commentId 评论 ID (required)
     * @param repliedUserId 被回复用户ID (required)
     * @param reply 回复内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userRepliesPostCall(Integer commentId, Integer repliedUserId, String reply, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/replies";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (commentId != null)
        localVarFormParams.put("commentId", commentId);
        if (repliedUserId != null)
        localVarFormParams.put("repliedUserId", repliedUserId);
        if (reply != null)
        localVarFormParams.put("reply", reply);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userRepliesPostValidateBeforeCall(Integer commentId, Integer repliedUserId, String reply, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'commentId' is set
        if (commentId == null) {
            throw new ApiException("Missing the required parameter 'commentId' when calling userRepliesPost(Async)");
        }
        
        // verify the required parameter 'repliedUserId' is set
        if (repliedUserId == null) {
            throw new ApiException("Missing the required parameter 'repliedUserId' when calling userRepliesPost(Async)");
        }
        
        // verify the required parameter 'reply' is set
        if (reply == null) {
            throw new ApiException("Missing the required parameter 'reply' when calling userRepliesPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userRepliesPostCall(commentId, repliedUserId, reply, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 用户回复评论
     * 
     * @param commentId 评论 ID (required)
     * @param repliedUserId 被回复用户ID (required)
     * @param reply 回复内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userRepliesPost(Integer commentId, Integer repliedUserId, String reply, String requestToken) throws ApiException {
        userRepliesPostWithHttpInfo(commentId, repliedUserId, reply, requestToken);
    }

    /**
     * 用户回复评论
     * 
     * @param commentId 评论 ID (required)
     * @param repliedUserId 被回复用户ID (required)
     * @param reply 回复内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userRepliesPostWithHttpInfo(Integer commentId, Integer repliedUserId, String reply, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userRepliesPostValidateBeforeCall(commentId, repliedUserId, reply, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 用户回复评论 (asynchronously)
     * 
     * @param commentId 评论 ID (required)
     * @param repliedUserId 被回复用户ID (required)
     * @param reply 回复内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userRepliesPostAsync(Integer commentId, Integer repliedUserId, String reply, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userRepliesPostValidateBeforeCall(commentId, repliedUserId, reply, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userReportPost
     * @param type 类型（建议：1，举报：2） (required)
     * @param content 内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userReportPostCall(Integer type, String content, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/report";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (type != null)
        localVarFormParams.put("type", type);
        if (content != null)
        localVarFormParams.put("content", content);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userReportPostValidateBeforeCall(Integer type, String content, String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'type' is set
        if (type == null) {
            throw new ApiException("Missing the required parameter 'type' when calling userReportPost(Async)");
        }
        
        // verify the required parameter 'content' is set
        if (content == null) {
            throw new ApiException("Missing the required parameter 'content' when calling userReportPost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userReportPostCall(type, content, requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 会员用户提交举报建议
     * 
     * @param type 类型（建议：1，举报：2） (required)
     * @param content 内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userReportPost(Integer type, String content, String requestToken) throws ApiException {
        userReportPostWithHttpInfo(type, content, requestToken);
    }

    /**
     * 会员用户提交举报建议
     * 
     * @param type 类型（建议：1，举报：2） (required)
     * @param content 内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userReportPostWithHttpInfo(Integer type, String content, String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userReportPostValidateBeforeCall(type, content, requestToken, null, null);
        return apiClient.execute(call);
    }

    /**
     * 会员用户提交举报建议 (asynchronously)
     * 
     * @param type 类型（建议：1，举报：2） (required)
     * @param content 内容 (required)
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userReportPostAsync(Integer type, String content, String requestToken, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userReportPostValidateBeforeCall(type, content, requestToken, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userUsersChangePasswordPut
     * @param oldPassword 旧密码 (required)
     * @param newPassword 新密码 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userUsersChangePasswordPutCall(String oldPassword, String newPassword, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/users/changePassword";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (oldPassword != null)
        localVarFormParams.put("oldPassword", oldPassword);
        if (newPassword != null)
        localVarFormParams.put("newPassword", newPassword);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userUsersChangePasswordPutValidateBeforeCall(String oldPassword, String newPassword, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'oldPassword' is set
        if (oldPassword == null) {
            throw new ApiException("Missing the required parameter 'oldPassword' when calling userUsersChangePasswordPut(Async)");
        }
        
        // verify the required parameter 'newPassword' is set
        if (newPassword == null) {
            throw new ApiException("Missing the required parameter 'newPassword' when calling userUsersChangePasswordPut(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userUsersChangePasswordPutCall(oldPassword, newPassword, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 修改密码
     * 
     * @param oldPassword 旧密码 (required)
     * @param newPassword 新密码 (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userUsersChangePasswordPut(String oldPassword, String newPassword) throws ApiException {
        userUsersChangePasswordPutWithHttpInfo(oldPassword, newPassword);
    }

    /**
     * 修改密码
     * 
     * @param oldPassword 旧密码 (required)
     * @param newPassword 新密码 (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userUsersChangePasswordPutWithHttpInfo(String oldPassword, String newPassword) throws ApiException {
        com.squareup.okhttp.Call call = userUsersChangePasswordPutValidateBeforeCall(oldPassword, newPassword, null, null);
        return apiClient.execute(call);
    }

    /**
     * 修改密码 (asynchronously)
     * 
     * @param oldPassword 旧密码 (required)
     * @param newPassword 新密码 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userUsersChangePasswordPutAsync(String oldPassword, String newPassword, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userUsersChangePasswordPutValidateBeforeCall(oldPassword, newPassword, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userUsersChangePhonePut
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userUsersChangePhonePutCall(String phone, String password, String textCode, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/users/changePhone";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (phone != null)
        localVarFormParams.put("phone", phone);
        if (password != null)
        localVarFormParams.put("password", password);
        if (textCode != null)
        localVarFormParams.put("textCode", textCode);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userUsersChangePhonePutValidateBeforeCall(String phone, String password, String textCode, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'phone' is set
        if (phone == null) {
            throw new ApiException("Missing the required parameter 'phone' when calling userUsersChangePhonePut(Async)");
        }
        
        // verify the required parameter 'password' is set
        if (password == null) {
            throw new ApiException("Missing the required parameter 'password' when calling userUsersChangePhonePut(Async)");
        }
        
        // verify the required parameter 'textCode' is set
        if (textCode == null) {
            throw new ApiException("Missing the required parameter 'textCode' when calling userUsersChangePhonePut(Async)");
        }
        
        
        com.squareup.okhttp.Call call = userUsersChangePhonePutCall(phone, password, textCode, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 修改手机号
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userUsersChangePhonePut(String phone, String password, String textCode) throws ApiException {
        userUsersChangePhonePutWithHttpInfo(phone, password, textCode);
    }

    /**
     * 修改手机号
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userUsersChangePhonePutWithHttpInfo(String phone, String password, String textCode) throws ApiException {
        com.squareup.okhttp.Call call = userUsersChangePhonePutValidateBeforeCall(phone, password, textCode, null, null);
        return apiClient.execute(call);
    }

    /**
     * 修改手机号 (asynchronously)
     * 
     * @param phone 手机号 (required)
     * @param password 密码 (required)
     * @param textCode 短信验证码 (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userUsersChangePhonePutAsync(String phone, String password, String textCode, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userUsersChangePhonePutValidateBeforeCall(phone, password, textCode, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for userUsersInfoGet
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userUsersInfoGetCall(String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/users/info";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded", "application/json", "multipart/form-data", "text/plain; charset=utf-8", "*/*"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userUsersInfoGetValidateBeforeCall(String requestToken, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = userUsersInfoGetCall(requestToken, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 会员用户获取个人信息
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return UserInfo
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public UserInfo userUsersInfoGet(String requestToken) throws ApiException {
        ApiResponse<UserInfo> resp = userUsersInfoGetWithHttpInfo(requestToken);
        return resp.getData();
    }

    /**
     * 会员用户获取个人信息
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @return ApiResponse&lt;UserInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<UserInfo> userUsersInfoGetWithHttpInfo(String requestToken) throws ApiException {
        com.squareup.okhttp.Call call = userUsersInfoGetValidateBeforeCall(requestToken, null, null);
        Type localVarReturnType = new TypeToken<UserInfo>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * 会员用户获取个人信息 (asynchronously)
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userUsersInfoGetAsync(String requestToken, final ApiCallback<UserInfo> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userUsersInfoGetValidateBeforeCall(requestToken, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<UserInfo>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userUsersInfoPut
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param name  (optional)
     * @param headImagePath  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userUsersInfoPutCall(String requestToken, String name, String headImagePath, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user/users/info";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (requestToken != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "requestToken", requestToken));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (name != null)
        localVarFormParams.put("name", name);
        if (headImagePath != null)
        localVarFormParams.put("headImagePath", headImagePath);

        final String[] localVarAccepts = {
            "application/json", "text/plain; charset=utf-8"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userUsersInfoPutValidateBeforeCall(String requestToken, String name, String headImagePath, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = userUsersInfoPutCall(requestToken, name, headImagePath, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * 会员用户修改个人信息
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param name  (optional)
     * @param headImagePath  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void userUsersInfoPut(String requestToken, String name, String headImagePath) throws ApiException {
        userUsersInfoPutWithHttpInfo(requestToken, name, headImagePath);
    }

    /**
     * 会员用户修改个人信息
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param name  (optional)
     * @param headImagePath  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> userUsersInfoPutWithHttpInfo(String requestToken, String name, String headImagePath) throws ApiException {
        com.squareup.okhttp.Call call = userUsersInfoPutValidateBeforeCall(requestToken, name, headImagePath, null, null);
        return apiClient.execute(call);
    }

    /**
     * 会员用户修改个人信息 (asynchronously)
     * 
     * @param requestToken IOS和Android端带的请求token (optional)
     * @param name  (optional)
     * @param headImagePath  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userUsersInfoPutAsync(String requestToken, String name, String headImagePath, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userUsersInfoPutValidateBeforeCall(requestToken, name, headImagePath, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
